#ifndef CREADFILE_CLASS
#define CREADFILE_CLASS
#include <windows.h>
#include <stdio.h>
#include "TextFile.h"

class CCfgFile : public CTextFile // the class that read file.
{
public:
	CCfgFile();
	CCfgFile( const char*, DWORD = READ_AND_WRITE, BOOL = FALSE );
	virtual ~CCfgFile();

	BOOL OpenFile( const char*, DWORD = READ_AND_WRITE, BOOL = FALSE );

	BOOL AnalyzeValue( char* );
	BOOL AnalyzeValue( void );
	BOOL WriteEntry( const char*, const char* );
	BOOL ModifyEntry( const char*, const char* );
	BOOL SetEnvironmentVariable( const char*, const char*,
									BOOL SystemSetting = TRUE, char* SystemDrive = NULL );
	BOOL SetEnvironmentVariableInRegistry( const char*, const char*, BOOL SystemSetting = TRUE );
	BOOL SetPathEnvironment( char*, char*, char* SystemFrive = NULL );
	BOOL SetPathEnvironmentInRegistry( char*, char* );
	BOOL DeletePathEnvironment( char* );
	BOOL SetPathEnvironment( char* );

	BOOL IsConfigLine( int ); // Check n th line contains configuration.
	const char* GetKey( int ); // return the key of the specified line.
	const char* GetValue( int );// return the value of the specified line.
	char* GetValue( char* );  // return the value to specified key.

protected:
	BOOL AnalyzeLine( int );
	BOOL AnalyzeLine( void );
	char* GetAutoexecFileName( char* );
	BOOL DeleteFolderName( char* current_list, char* delete_name );
	int AppendFolderName( char* current_list, int size_list, char* add_name );
	void InitializeValues( void );
	void CutOffComments( char*, int&, int );
	void CutOffHeadEquals( char*, int& );

private:
	char* NextLine( void );
	void FinishReading( void );
	int FindComment( char*, int& );
	BOOL AnalyzeLine( char*, char**, size_t&, char**, size_t& );
	int FindEqual( char*, int );
	BOOL PutKey( char*, char*, char**, size_t& );
	BOOL PutValue( char*, char*, int, char**, size_t& );

public:
protected:
	UINT m_nNextToRead;
	char* m_szKey;
	char* m_szValue;
	char* m_szBuffer;
private:
	int m_nCurrentAnalyzingLine;
	BOOL m_bResultAnalyzingLine;
};
#endif
