#include "StdAfx.h"
#include "CheckSum.h"

CheckSum& GetCheckSum( char* filename )
{
	static CheckSum cs;
	HANDLE hFile = CreateFile( filename,
						GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE,
						NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL );
	if( hFile == INVALID_HANDLE_VALUE )
	{
		cs.dwLastWritten.dwLowDateTime = 0;
		cs.dwLastWritten.dwHighDateTime = 0;
		cs.dwFileSize = 0;
		cs.dwCheckSum = 0;
		return cs;
	}
	GetFileTime( hFile, NULL, NULL, &(cs.dwLastWritten) );
	cs.dwFileSize = GetFileSize( hFile, NULL );
	cs.dwCheckSum = 0;
	unsigned char* file_data = new unsigned char[cs.dwFileSize+1];
	DWORD dwRead;
	BOOL r = ReadFile( hFile, file_data, cs.dwFileSize, &dwRead, NULL );
	if( r != FALSE )
	{
		for( UINT i = 0; i < cs.dwFileSize; i++ )
		{
			cs.dwCheckSum += file_data[i];
		}
	}
	delete[] file_data;
	CloseHandle( hFile );
	return cs;
}
