// DvipsPaper.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "guishell.h"
#include "DvipsPaper.h"
#include "util.h"
#include "TextFile.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern const char* g_TEXMF;

/////////////////////////////////////////////////////////////////////////////
// CDvipsPaper vpeB y[W

IMPLEMENT_DYNCREATE(CDvipsPaper, CPropertyPage)

CDvipsPaper::CDvipsPaper() : CPropertyPage(CDvipsPaper::IDD)
{
	m_arrayPaperFormat = NULL;
	//{{AFX_DATA_INIT(CDvipsPaper)
	m_bCreateEPS = FALSE;
	m_nEndPage = 0;
	m_nStartPage = 0;
	m_usePhysicalPage = -1;
	m_bLandscape = FALSE;
	m_bHyperTeX = FALSE;
	m_bShowDvipsBar = FALSE;
	//}}AFX_DATA_INIT
}

CDvipsPaper::~CDvipsPaper()
{
	if( m_arrayPaperFormat != NULL ) delete m_arrayPaperFormat;
}

void CDvipsPaper::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDvipsPaper)
	DDX_Control(pDX, IDC_SPIN_START_PAGE, m_spinStartPage);
	DDX_Control(pDX, IDC_SPIN_END_PAGE, m_spinEndPage);
	DDX_Control(pDX, IDC_COMBO_PAPER_FORMAT, m_comboPaperFormat);
	DDX_Check(pDX, IDC_CHECK_CREATE_EPS, m_bCreateEPS);
	DDX_Text(pDX, IDC_EDIT_END_PAGE, m_nEndPage);
	DDX_Text(pDX, IDC_EDIT_START_PAGE, m_nStartPage);
	DDX_Radio(pDX, IDC_RADIO_USE_LOGICAL_PAGE, m_usePhysicalPage);
	DDX_Check(pDX, IDC_CHECK_LANDSCAPE, m_bLandscape);
	DDX_Check(pDX, IDC_CHECK_HYPERTEX, m_bHyperTeX);
	DDX_Check(pDX, IDC_CHECK_SHOW_DVIPS_BAR, m_bShowDvipsBar);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDvipsPaper, CPropertyPage)
	//{{AFX_MSG_MAP(CDvipsPaper)
	ON_BN_CLICKED(IDC_BUTTON_PAGE, OnButtonPage)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDvipsPaper bZ[W nh

BOOL CDvipsPaper::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	m_spinStartPage.SetRange( 0, UD_MAXVAL );
	m_spinEndPage.SetRange( 0, UD_MAXVAL );

	if( m_arrayPaperFormat != NULL )
	{
		delete m_arrayPaperFormat;
		m_arrayPaperFormat = NULL;
	}
	m_arrayPaperFormat = new CDynamicCharArray;

	char* texmf = new char[1];
	DWORD size = GetEnvironmentVariable( g_TEXMF, texmf, 1 );
	delete[] texmf;
	texmf = new char[size+24];
	GetEnvironmentVariable( g_TEXMF, texmf, size+24 );
	SlashToYen( texmf );
	int y = lstrlen( texmf );
	lstrcat( texmf, "\\dvips\\config.ps" );
	CTextFile config( texmf, READONLY );
	if( config.IsOpenedFile() == FALSE )
	{
		texmf[y] = NULL;
		lstrcat( texmf, "\\dvips\\config\\config.ps" );
		config.OpenFile( texmf, READONLY );
		if( config.IsOpenedFile() == FALSE )
		{
			(*m_arrayPaperFormat) << "";
			delete[] texmf;
			return TRUE;
		}
	}
	delete[] texmf;
	for( UINT i = 1; i <= config.GetNumberOfLines(); i++ )
	{
		const char* line = config.GetTheLine( i );
		if( line[0] != '@' ) continue;
		if( lstrlen(line) < 3 ) continue;
		if( line[1] != ' ' ) continue;
		int l = lstrlen( line + 2 );
		char* name = new char[l+1];
		lstrcpy( name, line+2 );
		int s = FindFirstChar( name, ' ' );
		if( s != -1 ) name[s] = NULL;
		m_comboPaperFormat.AddString( name );
		(*m_arrayPaperFormat) << name;
		delete[] name;
	}
	m_strPaperFormat = AfxGetApp()->GetProfileString( "dvips", "PaperFormat", "a4paper" );
	if( m_comboPaperFormat.SelectString(0, m_strPaperFormat) == CB_ERR )
	{
		m_comboPaperFormat.SetCurSel( 0 );
	}
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CDvipsPaper::OnOK() 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	int n = m_comboPaperFormat.GetCurSel();
	if( n == CB_ERR ) n = 0;
	m_strPaperFormat = (*m_arrayPaperFormat)[n];
	CPropertyPage::OnOK();
}

void CDvipsPaper::OnButtonPage() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	m_nStartPage = m_nEndPage = 0;
	CEdit* pStart = (CEdit*)GetDlgItem(IDC_EDIT_START_PAGE);
	CEdit* pEnd = (CEdit*)GetDlgItem(IDC_EDIT_END_PAGE);
	pStart->SetWindowText( "0" );
	pEnd->SetWindowText( "0" );
}

