/************************************
 Copyright(C) 1998 by Yoshiki OTOBE.
   All rights reserved.
************************************/

#ifndef INCLUDE_DYNAMIC_ARRAY_H
#define INCLUDE_DYNAMIC_ARRAY_H
#include <windows.h>

template<class T>
class CDynamicArray
{
public:
	CDynamicArray();
	~CDynamicArray();

	T** GetAddressOfArray( void );
	UINT GetSizeOfArray( void );
	const UINT GetLastIndexOfArray( void );

	T* GetAddressOfList( void );
	UINT GetSizeOfList( void );

	void SetIncrementSize( UINT, UINT );

	BOOL AddMember( const T*, UINT size = sizeof(T) );
	BOOL ReplaceTheMemberOf( UINT, const T*, UINT size = sizeof(T) );
	BOOL IsElementExist( void );

	T* GetMemberOf( UINT );
	void DeleteLastMember( void );

	BOOL operator<<( T );
	T* operator[]( UINT );
	
protected:
	T* GetLastPointerOfList( void );
	T* GetNextPointerOfList( void );
	BOOL ResizeArray( void );
	BOOL ResizeList( void );
	void SetUsedSizeOfList( size_t );
	BOOL SetSizeOfArray( size_t );
	BOOL SetSizeOfList( size_t );
	void GarbageCollection( T*, UINT );

public:
protected:
	T** m_ppArray;
	T*  m_pList;
	/* HANDLE m_hProcessHeap; */
	UINT m_nArraySize;   // array size.
	UINT m_nUsedArraySize;    // used size of array.
	UINT m_nArrayIncrement;   // the size to increment the array.
	UINT m_nListSize;    // the size of the list.
	size_t m_nUsedListSize;// used size of list.
	UINT m_nListIncrement;    // the size to increment the list.
	CRITICAL_SECTION m_CriticalSection;
};
//typedef CDynamicArray<char> CDynamicCharArray;
class CDynamicCharArray : public CDynamicArray<char>
{
public:
	BOOL operator<<( char* );
	BOOL operator<<( const char* );
};

#include "DynamicArray.cpp"
#endif
