// MakeIndexOption.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "guishell.h"
#include "MakeIndexOption.h"
#include "util.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern const char* g_TEXMF;
/////////////////////////////////////////////////////////////////////////////
// CMakeIndexOption _CAO


CMakeIndexOption::CMakeIndexOption(CWnd* pParent /*=NULL*/)
	: CDialog(CMakeIndexOption::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMakeIndexOption)
	m_bUseLetterOrdering = FALSE;
	m_bDisableImplicitPageFormation = FALSE;
	m_bEnableBlankCompression = FALSE;
	m_bMakeJapaneseIndexHead = FALSE;
	m_bForceToOutputKanji = FALSE;
	//}}AFX_DATA_INIT
}


void CMakeIndexOption::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMakeIndexOption)
	DDX_Control(pDX, IDC_COMBO_PAGE, m_comboPage);
	DDX_Control(pDX, IDC_EDIT_STYLE, m_editStyle);
	DDX_Control(pDX, IDC_EDIT_DICTIONARY, m_editDictionary);
	DDX_Check(pDX, IDC_CHECK_USE_LETTER_ORDERING, m_bUseLetterOrdering);
	DDX_Check(pDX, IDC_CHECK_DISABLE_IMPLICIT_PAGE_FORMATION, m_bDisableImplicitPageFormation);
	DDX_Check(pDX, IDC_CHECK_ENABLE_BLANK_COMPRESSION, m_bEnableBlankCompression);
	DDX_Check(pDX, IDC_CHECK_MAKE_JAPANESE_INDEX_HEAD, m_bMakeJapaneseIndexHead);
	DDX_Check(pDX, IDC_CHECK_FORCE_TO_OUTPUT_KANJI, m_bForceToOutputKanji);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMakeIndexOption, CDialog)
	//{{AFX_MSG_MAP(CMakeIndexOption)
	ON_BN_CLICKED(IDC_BUTTON_REF_STYLE, OnButtonRefStyle)
	ON_BN_CLICKED(IDC_BUTTON_REF_DIC, OnButtonRefDic)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMakeIndexOption bZ[W nh

BOOL CMakeIndexOption::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_strStyle = AfxGetApp()->GetProfileString( "MakeIndex", "IndexStyle" );
	m_strDictionary = AfxGetApp()->GetProfileString( "MakeIndex", "Dictionary" );
	m_strPage = AfxGetApp()->GetProfileString( "MakeIndex", "IndexStartPage", "any" );
	m_editStyle.SetWindowText( m_strStyle );
	m_editDictionary.SetWindowText( m_strDictionary );
	if( m_comboPage.SelectString( -1, m_strPage ) == CB_ERR )
	{
		m_comboPage.AddString( m_strPage );
		m_comboPage.SelectString( -1, m_strPage );
	}
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CMakeIndexOption::OnButtonRefStyle() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	char* texmf = new char[1];
	DWORD size = GetEnvironmentVariable( g_TEXMF, texmf, 1 );
	delete[] texmf;
	texmf = new char[size+11];
	GetEnvironmentVariable( g_TEXMF, texmf, size + 11 );
	lstrcat( texmf, "\\makeindex" );
	SlashToYen( texmf );

	char* cur_dir = new char[1];
	DWORD size_cur_dir = GetCurrentDirectory( 1, cur_dir );
	delete[] cur_dir;
	cur_dir = new char[size_cur_dir+1];
	GetCurrentDirectory( size_cur_dir + 1, cur_dir );

//	SetCurrentDirectory( texmf );

	char szMapFile[] = 
		"Index Style File(*.ist)|*.ist|"
		"All files(*.*)|*.*||";
	CFileDialog dlgFile( TRUE, "ist", NULL, OFN_HIDEREADONLY
	            | OFN_FILEMUSTEXIST | OFN_LONGNAMES 
				| OFN_NONETWORKBUTTON , szMapFile );
	dlgFile.m_ofn.lpstrInitialDir = texmf;
	if( dlgFile.DoModal() == IDOK )
	{
		m_editStyle.SetWindowText( dlgFile.GetFileName() );
	}

	SetCurrentDirectory( cur_dir );

	delete[] cur_dir;
	delete[] texmf;
}

void CMakeIndexOption::OnButtonRefDic() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	char* texmf = new char[1];
	DWORD size = GetEnvironmentVariable( g_TEXMF, texmf, 1 );
	delete[] texmf;
	texmf = new char[size+11];
	GetEnvironmentVariable( g_TEXMF, texmf, size + 11 );
	lstrcat( texmf, "\\makeindex" );
	SlashToYen( texmf );

	char* cur_dir = new char[1];
	DWORD size_cur_dir = GetCurrentDirectory( 1, cur_dir );
	delete[] cur_dir;
	cur_dir = new char[size_cur_dir+1];
	GetCurrentDirectory( size_cur_dir + 1, cur_dir );

//	SetCurrentDirectory( texmf );

	char szDicFile[] = 
		"Index Dictionary File(*.dic)|*.dic|"
		"All files(*.*)|*.*||";
	CFileDialog dlgFile( TRUE, "dic", NULL, OFN_HIDEREADONLY
	            | OFN_FILEMUSTEXIST | OFN_LONGNAMES 
				| OFN_NONETWORKBUTTON , szDicFile );
	dlgFile.m_ofn.lpstrInitialDir = texmf;
	if( dlgFile.DoModal() == IDOK )
	{
		m_editDictionary.SetWindowText( dlgFile.GetFileName() );
	}

	SetCurrentDirectory( cur_dir );

	delete[] cur_dir;
	delete[] texmf;
}

void CMakeIndexOption::OnOK() 
{
	// TODO: ̈ʒuɂ̑̌ؗp̃R[hǉĂ
	m_editStyle.GetWindowText( m_strStyle );
	m_editDictionary.GetWindowText( m_strDictionary );
	m_comboPage.GetWindowText( m_strPage );
	CDialog::OnOK();
}
