template<class T>
CQueue<T>::CQueue()
{
	m_sizeArray = 16;
	m_sizeUsedArray = 0;
	m_hProcessHeap = GetProcessHeap();
	m_array = static_cast<T*>( HeapAlloc(m_hProcessHeap, NULL, m_sizeArray*sizeof(T)) );
}

template<class T>
CQueue<T>::~CQueue()
{
	HeapFree( m_hProcessHeap, NULL, m_array );
}

template<class T>
void CQueue<T>::Push( const T& mem )
{
	if( m_sizeUsedArray == m_sizeArray - 1 )
	{
		m_sizeArray += 16;
		m_array = static_cast<T*>(
					HeapReAlloc(m_hProcessHeap, NULL, m_array, m_sizeArray*sizeof(T)) );
	}
	m_sizeUsedArray++;
	m_array[m_sizeUsedArray-1] = mem;
	return;
}

template<class T>
const T CQueue<T>::Pop( void )
{
	if( m_sizeUsedArray == 0 ) return 0;
	T ret = m_array[0];
	m_sizeUsedArray--;
	memmove( m_array, m_array + 1, m_sizeUsedArray*sizeof(T) );
	return ret;
}
