// RegistFormatFile.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "guishell.h"
#include "RegistFormatFile.h"
#include "DynamicArray.h"
#include "util.h"
#include "CfgFile.h"
#include <memory.h>
#include "FmtProperty.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRegistFormatFile _CAO


CRegistFormatFile::CRegistFormatFile(CWnd* pParent /*=NULL*/)
	: CDialog(CRegistFormatFile::IDD, pParent)
{
	m_nLastIndexOfFormatFiles = 0;
	m_parrayRegFmt = NULL;
	//{{AFX_DATA_INIT(CRegistFormatFile)
	m_bShowFormatBar = FALSE;
	//}}AFX_DATA_INIT
}


void CRegistFormatFile::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRegistFormatFile)
	DDX_Control(pDX, IDC_BUTTON_FMT_PROPERTY, m_buttonProperty);
	DDX_Control(pDX, IDC_LIST_REGISTED_FORMATFILE, m_listRegist);
	DDX_Control(pDX, IDC_LIST_FORMATFILES, m_listFormatFiles);
	DDX_Check(pDX, IDC_CHECK_SHOW_FORMAT_BAR, m_bShowFormatBar);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CRegistFormatFile, CDialog)
	//{{AFX_MSG_MAP(CRegistFormatFile)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_SHOW_TEXMFCNF, OnButtonShowTexmfcnf)
	ON_BN_CLICKED(IDC_BUTTON_FMT_PROPERTY, OnButtonFmtProperty)
	ON_BN_CLICKED(IDC_BUTTON_GUISHELL_CFG, OnButtonGuishellCfg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRegistFormatFile bZ[W nh

BOOL CRegistFormatFile::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	if( m_parrayRegFmt != NULL ) delete m_parrayRegFmt;
	m_parrayRegFmt = new CDynamicCharArray;
	BOOL exist_formatfile = FALSE;
	char* texmfcnf = new char[1];
	DWORD texmfcnf_size = GetEnvironmentVariable( "TEXMFCNF", texmfcnf, 1 );
	if( texmfcnf_size == 0 )
	{
		MessageBox( "Emergency STOP!\n"
			"I couldn't find TEXMFCNF environment variable.\n"
			"You have to call your system administrator or\n"
			"set TEXMFCNF variable." );
		return FALSE;
	}
	delete[] texmfcnf;
	texmfcnf = new char[texmfcnf_size+1];
	GetEnvironmentVariable( "TEXMFCNF", texmfcnf, texmfcnf_size + 1 );
	CDynamicCharArray texmfcnf_dir;
	UINT i, j;
	j = 0;
	for( i = 0; i < (UINT)lstrlen(texmfcnf); i++ )
	{
		if( texmfcnf[i] == ';' )
		{
			char* temp = new char[i-j+1];
			memcpy( temp, texmfcnf + j, i-j );
			temp[i-j] = NULL;
			texmfcnf_dir << temp;
			delete[] temp;
			j = i + 1;
		}
	}
	texmfcnf_dir << texmfcnf + j;
	delete[] texmfcnf;
	for( i = 0; i <= texmfcnf_dir.GetLastIndexOfArray(); i++ )
	{
		char* fmtfile;
		int l = lstrlen( texmfcnf_dir[i] );
		l += 7;
		fmtfile = new char[l];
		wsprintf( fmtfile, "%s\\*.fmt", texmfcnf_dir[i] );
		SlashToYen( fmtfile );
		WIN32_FIND_DATA ffd;

		HANDLE hFind = FindFirstFile( fmtfile, &ffd );
		if( hFind == INVALID_HANDLE_VALUE )
		{
			delete[] fmtfile;
			continue;
		}
		else
		{
			exist_formatfile = TRUE;
			m_listFormatFiles.AddString( ffd.cFileName );
			m_arrayFormatFiles << ffd.cFileName;
			m_nLastIndexOfFormatFiles++;
		}
		while( FindNextFile(hFind, &ffd) != FALSE )
		{
			m_listFormatFiles.AddString( ffd.cFileName );
			m_arrayFormatFiles << ffd.cFileName;
			m_nLastIndexOfFormatFiles++;
		}
		FindClose( hFind );
		delete[] fmtfile;
	}
	if( exist_formatfile == FALSE )
	{
		MessageBox( "There is no format file on your computer\n"
			"or TEXMFCNF is not set correctly.\n"
			"Call your system administrator as soon as possible." );
		return FALSE;
	}
	InitializeList();
	SetTimer( 1, 100, NULL );
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CRegistFormatFile::OnCancel() 
{
	// TODO: ̈ʒuɓʂȌ㏈ǉĂB
	KillTimer( 1 );
	delete m_parrayRegFmt;
	CDialog::OnCancel();
}

void CRegistFormatFile::OnOK() 
{
	// TODO: ̈ʒuɂ̑̌ؗp̃R[hǉĂ
	KillTimer( 1 );
	CCfgFile cfg( "guishell.cfg", READ_AND_WRITE, TRUE );
	if( cfg.IsOpenedFile() == FALSE )
	{
		MessageBox( "You cannot open guishell.cfg file to write the formatfiles.\n"
			"You may not be allowed to modify the file.\n"
			"Call and ask your system administrator to add new format files." );
		CDialog::OnOK();
		delete m_parrayRegFmt;
		return;
	}
	ReConstructRegFmt();
	char index[4];
	UINT max_index = min( 999,m_parrayRegFmt->GetLastIndexOfArray() );
	wsprintf( index, "%d", max_index );
	cfg.ModifyEntry( "index", index );
	AfxGetApp()->WriteProfileInt( "Format Files", "index", max_index );
	for( UINT i = 0; i <= max_index; i++ )
	{
		char str[14];
		wsprintf( str, "FormatFile%d", i );
		const char* formatfile = (*m_parrayRegFmt)[i];
		cfg.ModifyEntry( str, formatfile );
		AfxGetApp()->WriteProfileString( "Format Files", str, formatfile );
	}
	delete m_parrayRegFmt;
	CDialog::OnOK();
}

void CRegistFormatFile::OnTimer(UINT_PTR nIDEvent) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	CheckedFormatFileToReg();
	UncheckedFormatFileToUnreg();
	if( m_listRegist.GetCurSel() == LB_ERR )
		m_buttonProperty.EnableWindow( FALSE );
	else
		m_buttonProperty.EnableWindow( TRUE );
	CDialog::OnTimer(nIDEvent);
	return;
}

void CRegistFormatFile::OnButtonShowTexmfcnf() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	char* texmfcnf = new char[1];
	DWORD texmfcnf_size = GetEnvironmentVariable( "TEXMFCNF", texmfcnf, 1 );
	delete[] texmfcnf;
	if( texmfcnf_size == 0 )
	{
		MessageBox( "TEXMFCNF is not found in your environment variables.\n"
			"Communicate to your manager to set up this system." );
		return;
	}
	texmfcnf = new char[texmfcnf_size + 1];
	GetEnvironmentVariable( "TEXMFCNF", texmfcnf, texmfcnf_size + 1 );
	MessageBox( texmfcnf, "TEXMFCNF" );
	delete[] texmfcnf;
	return;
}

void CRegistFormatFile::InitializeList( void )
{
	CCfgFile cfg( "guishell.cfg", READONLY );
	BOOL exist_format = FALSE;
	if( cfg.IsOpenedFile() == FALSE )
	{
		MessageBox( "guishell.cfg file is not found.\n"
			"If you use this menu first, this message will always appear.\n"
			"However, if not, this message means there is a terrible miss setting.\n"
			"Call your system administrator as soon as possible." );
		(*m_parrayRegFmt) << "cgݑΉLaTeX2e(platex.fmt)";
		m_listRegist.AddString( (*m_parrayRegFmt)[0] );
		CheckRegistedFormatFile();
		return;
	}
	const char* temp = cfg.GetValue( "index" );
	int last_index;
	if( temp == NULL )
	{
		temp = "9";
		last_index = 9;
	}
	else
		last_index = atoi( temp );
	int size_key = lstrlen(temp) + 11;
	char* key = new char[size_key];
	for( int i = 0; i <= last_index; i++ )
	{
		wsprintf( key, "FormatFile%d", i );
		char* fmt = cfg.GetValue( key );
		if( fmt == NULL )
		{
			wsprintf( key, "%d", i );
			fmt = cfg.GetValue( key );
			if( fmt == NULL ) continue;
		}
		(*m_parrayRegFmt) << fmt;
		exist_format = TRUE;
	}
	delete[] key;
	if( exist_format == FALSE )
		(*m_parrayRegFmt) << "cgݑΉLaTeX2e(platex.fmt)";
	for( int i = 0; i <= (signed)(*m_parrayRegFmt).GetLastIndexOfArray(); i++ )
	{
		m_listRegist.AddString( (*m_parrayRegFmt)[i] );
	}
	CheckRegistedFormatFile();
}	

void CRegistFormatFile::CheckRegistedFormatFile( void )
{
	char* formatfile;
	UINT i, j;
	for( i = 0; i <= (*m_parrayRegFmt).GetLastIndexOfArray(); i++ )
	{
		int l = lstrlen( (*m_parrayRegFmt)[i] );
		formatfile = new char[l+1];
		lstrcpy( formatfile, (*m_parrayRegFmt)[i] );
		int k = FindLastChar( formatfile, '(' );
		if( k != -1 )
		{
			int size = l - k - 2;
			memmove( formatfile, formatfile+k+1, size );
			formatfile[size] = NULL;
		}
		k = FindLastChar( formatfile, '.' );
		if( k != -1 ) formatfile[k] = NULL;
		for( j = 0; j <= m_arrayFormatFiles.GetLastIndexOfArray(); j++ )
		{
			int r = lstrlen( m_arrayFormatFiles[j] );
			char* ondisk_fmt = new char[r+1];
			lstrcpy( ondisk_fmt, m_arrayFormatFiles[j] );
			k = FindLastChar( ondisk_fmt, '.' );
			if( k != -1 ) ondisk_fmt[k] = NULL;
			if( lstrcmpi(ondisk_fmt, formatfile) == 0 )
			{
				m_listFormatFiles.SetCheck( j, 1 );
				delete[] ondisk_fmt;
				break;
			}
			delete[] ondisk_fmt;
		}
		delete[] formatfile;
	}
	return;
}

void CRegistFormatFile::CheckedFormatFileToReg( void )
{
	UINT i, j;
	for( i = 0; i <= m_arrayFormatFiles.GetLastIndexOfArray(); i++ )
	{
		if( m_listFormatFiles.GetCheck(i) == 1 )
		{ /* The i-th formatfile is checked. */
			int l = lstrlen( m_arrayFormatFiles[i] );
			char* formatfile = new char[l+1];
			lstrcpy( formatfile, m_arrayFormatFiles[i] );
			j = FindLastChar( formatfile, '.' );
			if( j != -1 ) formatfile[j] = NULL;
			/* Check i-th fmt file is registed. */
			for( j = 0; j <= (*m_parrayRegFmt).GetLastIndexOfArray(); j++ )
			{
				int r = lstrlen( (*m_parrayRegFmt)[j] );
				char* regfmt = new char[r+1];
				lstrcpy( regfmt, (*m_parrayRegFmt)[j] );
				int k = FindLastChar( regfmt, '(' );
				if( k != -1 )
				{
					memmove( regfmt, regfmt+k+1, r-k-2 );
					regfmt[r-k-1] = NULL;
				}
				k = FindLastChar( regfmt, '.' );
				if( k != -1 ) regfmt[k] = NULL;
				if( lstrcmpi(formatfile, regfmt) == 0 )
				{ /* registed. */
					delete[] regfmt;
					goto registed;
				}
				else
				{
					delete[] regfmt;
					continue;
				}
			}
			lstrcat( formatfile, ".fmt" );
			m_listRegist.AddString( formatfile );
			(*m_parrayRegFmt) << formatfile;
			registed:;
			delete[] formatfile;
			continue; // check next checked item.
		}
		else continue;
	}
	return;
}

void CRegistFormatFile::UncheckedFormatFileToUnreg( void )
{
	UINT i,j;
	for( i = 0; i <= m_arrayFormatFiles.GetLastIndexOfArray(); i++ )
	{
		if( m_listFormatFiles.GetCheck(i) == 0 )
		{ /* The i-th formatfile is NOT checked. */
			int l = lstrlen( m_arrayFormatFiles[i] );
			char* formatfile = new char[l+1];
			lstrcpy( formatfile, m_arrayFormatFiles[i] );
			j = FindLastChar( formatfile, '.' );
			if( j != -1 ) formatfile[j] = NULL;
			/* Check i-th fmt file is registed. */
			for( j = 0; j <= (*m_parrayRegFmt).GetLastIndexOfArray(); j++ )
			{
				CString str_regfmt;
				m_listRegist.GetText( j, str_regfmt );
				int r = lstrlen( str_regfmt );
				char* regfmt = new char[r+1];
				lstrcpy( regfmt, str_regfmt );
				int k = FindLastChar( regfmt, '(' );
				if( k != -1 )
				{
					memmove( regfmt, regfmt+k+1, r-k-2 );
					regfmt[r-k-1] = NULL;
				}
				k = FindLastChar( regfmt, '.' );
				if( k != -1 ) regfmt[k] = NULL;
				if( lstrcmpi(formatfile, regfmt) == 0 )
				{ /* registed. we must delete it. */
					delete[] regfmt;
					goto registed;
				}
				else
				{
					delete[] regfmt;
					continue;
				}
			}
			delete[] formatfile;
			continue;
			registed:;
			delete[] formatfile;
			m_listRegist.DeleteString( j );
			ReConstructRegFmt();
			continue; // check next checked item.
		}
		else continue;
	}
	return;
}

void CRegistFormatFile::ReConstructRegFmt( void )
{
	if( m_parrayRegFmt != NULL ) delete m_parrayRegFmt;
	m_parrayRegFmt = new CDynamicCharArray;
	for( int i = 0; i <= m_listRegist.GetCount() - 1; i++ )
	{
		CString str_regfmt;
		m_listRegist.GetText( i, str_regfmt );
		(*m_parrayRegFmt) << str_regfmt;
	}
	return;
}

void CRegistFormatFile::OnButtonFmtProperty() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CFmtProperty dlg;
	int index = m_listRegist.GetCurSel();
	if( index == LB_ERR ) return;
	CString strFmtFile;
	m_listRegist.GetText( index, strFmtFile );
	BOOL have_property = FALSE;
	int paren = 0;
	int k = FindLastChar( strFmtFile, '(' );
	if( k != -1 )
	{
		have_property = TRUE;
		paren = k;
	}
	if( have_property == FALSE )
	{
		int l = lstrlen( strFmtFile );
		char* fmtfile = new char[l+1];
		lstrcpy( fmtfile, strFmtFile );
		k = FindLastChar( fmtfile, '.' );
		if( k != -1 ) fmtfile[k] = NULL;
		dlg.m_strFormatFile = fmtfile;
		dlg.m_strProperty = "";
		delete[] fmtfile;
	}
	else
	{
		int l = lstrlen( strFmtFile );
		char* property = new char[l+1];
		char* fmtfile = new char[l+1];
		memcpy( property, strFmtFile, paren );
		property[paren] = NULL;
		memcpy( fmtfile, (const char*)strFmtFile + paren + 1, l - paren - 2 );
		fmtfile[l-paren-2] = NULL;
		k = FindLastChar( fmtfile, '.' );
		if( k != -1 ) fmtfile[k] = NULL;
		dlg.m_strFormatFile = fmtfile;
		dlg.m_strProperty = property;
		delete[] fmtfile;
		delete[] property;
	}
	open_dlg:;
	if( dlg.DoModal() == IDOK )
	{
		if( dlg.m_strProperty.Find( '(' ) != -1 )
		{
			MessageBox( "\ɔp ( p邱Ƃ͂ł܂B" );
			goto open_dlg;
		}
		m_listRegist.DeleteString( index );
		CString strProperty = dlg.m_strProperty;
		strProperty += "(";
		strProperty += dlg.m_strFormatFile;
		if( dlg.m_bUseExe )
			strProperty += ".exe";
		else
			strProperty += ".fmt";
		strProperty += ")";
		m_listRegist.InsertString( index, strProperty );
		ReConstructRegFmt();
	}
}

void CRegistFormatFile::OnButtonGuishellCfg() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CCfgFile cfg( "guishell.cfg", READONLY );
	if( cfg.IsOpenedFile() == FALSE )
	{
		MessageBox( "guishell.cfg file is not found on your system,\n"
			"i.e., on your home directory (WindowsNT only), the current directory,\n"
			"the directory which this process is in, and in the search parh.\n"
			"You have to call your system adminstrator to set up the TeX\n"
			"with using guishell program." );
			return;
	}
	MessageBox( cfg.GetFileName(), "guishell.cfg" );
}
