template<class T>
CStack<T>::CStack()
{
	m_sizeArray = 16;
	m_sizeUsedArray = 0;
	m_hProcessHeap = GetProcessHeap();
	m_array = static_cast<T*>( HeapAlloc(m_hProcessHeap, NULL, m_sizeArray*sizeof(T)) );
}

template<class T>
CStack<T>::~CStack()
{
	HeapFree( m_hProcessHeap, NULL, m_array );
}

template<class T>
void CStack<T>::Push( const T& mem )
{
	if( m_sizeUsedArray == m_sizeArray - 1 )
	{
		m_sizeArray += 16;
		m_array = static_cast<T*>(
					HeapReAlloc(m_hProcessHeap, NULL, m_array, m_sizeArray*sizeof(T)) );
	}
	m_sizeUsedArray++;
	m_array[m_sizeUsedArray-1] = mem;
	return;
}

template<class T>
const T& CStack<T>::Pop( void )
{
	ASSERT( m_sizeUsedArray > 0 );
	m_sizeUsedArray--;
	return m_array[m_sizeUsedArray];
}
