/*****************************************************************************
   This file provides utility functions.
   Copyright(C) 1998 by Yoshiki OTOBE.
******************************************************************************/

#ifndef INCLUDE_UTIL_H
#define INCLUDE_UTIL_H
#include "DynamicArray.h"

struct ERROR_INFO
{
	BOOL error_exist;
	BOOL tex_error; // serious error.
	BOOL cite_warning;
	BOOL label_change;
	BOOL undef_label;
};

const BOOL IsWindowsNT( void );
const BOOL IsSignaled( HANDLE );
const int  GetDefaultPrinterDPI( void );
void YenToSlash( char* );
void SlashToYen( char* );
BOOL IsError( const char* );
BOOL IsLaTeXError( const char* );
BOOL IsLaTeXWarning( const char* );
BOOL IsLaTeXFontWarning( const char* );
BOOL IsTeXWarning( const char* );
BOOL IsGuishellMessage( const char* );
BOOL IsDvipsMessage( const char* );
BOOL IsDvipsError( const char* );
BOOL IsKpathseaMessage( const char* );
BOOL IsKanji1( const unsigned char );
BOOL GuessTEXMF( void );
void CutoffDirectoryOneLevel( char* );
BOOL IsExistChildDirectory( char*, char* );
BOOL IsFileExist( const char* );
void SearchHardDisk( CDynamicCharArray* );
void SearchCDROM( CDynamicCharArray* );
BOOL GuessGSDirectory( void );
BOOL GuessAcrobatDirectory( void );
BOOL SetExecutablePath( void );
int FindFirstChar( const char*, char );
int FindLastChar( const char*, char );
ERROR_INFO& CreateErrorInformation( CDynamicCharArray*, CDynamicCharArray*, BOOL = TRUE );
BOOL ContainString( const char*, const char* );
CString& GetTEXMFCNF( void );
char* ReplaceString( char*, const char*, const char* );
void CopyTEXMF( char* dest );
CString& PickupLine( const char*, const char* );
DWORD GetStringCheckSum( const char* );
void GetTeXInternalConstants( void );
BOOL NeedStop( const char* );
int IndexOfNonSpace( const char* );
inline int get_max_print_line( void );

inline BOOL CompareChars( char a, char b )
{
	if( a == b ) return TRUE;
	else return FALSE;
}

inline BOOL CompareFirstString( const char* target, const char* str )
{
	int i = 0;
	while(TRUE) // inifinite loop.
	{
		if( str[i] == NULL ) return TRUE;
		if( target[i] != str[i] ) return FALSE;
		i++;
	}
/*

	int lt = lstrlen( target );
	int ls = lstrlen( str );
	if( lt < ls ) return FALSE;
	for( int i = 0; i < ls; i++ )
	{
		if( CompareChars( str[i], target[i] ) == TRUE ) continue;
		else return FALSE;
	}
	return TRUE;
*/
}

#endif
