// guishellDoc.cpp : CGuishellDoc NX̓̒`s܂B
//

#include "stdafx.h"
#include "guishell.h"

#include "MainFrm.h"
#include "guishellDoc.h"
#include "guishellView.h"
#include "util.h"
#include "ConsoleTask.h"
#include "UserInput.h"
#include "extention.h"
#include "GeneralDialog.h"
#include "AsklatexDialog.h"
#include "DVIProperty.h"
#include "PSProperty.h"
#include "TeXProperty.h"
#include "IDXProperty.h"
#include "SrcTeXProperty.h"
#include "RegistFormatFile.h"
#include "CfgFile.h"
#include "TerminateDialog.h"
#include "CheckSum.h"
#include "Stack.h"
#include "Queue.h"
#include "MakeIndexOption.h"
#include "DvipsPaper.h"
#include "DvipsPrinter.h"
#include "CommandDialog.h"
#include "L2HGeneralDlg.h"
#include "L2HMathDlg.h"
#include <shlobj.h> // IShellLink

extern CRITICAL_SECTION g_csDde;

struct tagDVIPSpaper
{
	BOOL use_struct;
	int start_page;
	int end_page;
	BOOL use_physical;
	BOOL create_eps;
	BOOL landscape;
	BOOL hypertex;
	CString paper_format;
};

static tagDVIPSpaper DVIPSpaper;
static int pre_log_filetype = 0;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const DWORD NOPROCESS = 0;
const DWORD FILENAME_ONLY = 1;
const DWORD NEED_FULLPATH = 2;
const DWORD ACROBAT_DISTILLER = 3;
const DWORD CUT_EXTENTION = 4;
const DWORD PS2PDF = 5;
const DWORD RUN_ONLY = 6;

const DWORD LaTeX     = 1;
const DWORD MakeIndex = 2;
const DWORD BibTeX    = 4;

const DWORD PROCESS_ONCE = 1;
const DWORD PROCESS_COMPLETE = 2;

BOOL given_commandline_param;

HWND g_hWndView;

BOOL dde_mode;
BOOL tell_line;
DWORD process_type;
int g_FormatIndexByCommand; // TRUE if format file is specified on command line.
char* g_szFileName;
char* g_szDdeData = NULL;
BOOL shell_exec;
BOOL force_src;
BOOL force_no_src;

struct tagSRCTEX{
	BOOL m_nType; // 0: srctex.exe, 1: (p)tex.exe
	BOOL m_bCR;
	BOOL m_bDISPLAY;
	BOOL m_bHBOX;
	BOOL m_bMATH;
	BOOL m_bPAR;
	BOOL m_bPAREND;
	BOOL m_bVBOX;
} srctex;
const int SRCTEXEXE = 0;
const int SRCTEXTEX = 1;

extern const char* g_TEXMF;
/////////////////////////////////////////////////////////////////////////////
// CGuishellDoc

IMPLEMENT_DYNCREATE(CGuishellDoc, CDocument)

BEGIN_MESSAGE_MAP(CGuishellDoc, CDocument)
	//{{AFX_MSG_MAP(CGuishellDoc)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_GENERAL, OnGeneral)
	ON_COMMAND(ID_PROGRAM_SETTINGS, OnProgramSettings)
	ON_COMMAND(ID_REGIST_FORMAT_FILE, OnRegistFormatFile)
	ON_COMMAND(ID_MAKEINDEX_OPTION, OnMakeindexOption)
	ON_COMMAND(ID_DVIPS_OPTION, OnDvipsOption)
	ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE_AS, OnUpdateFileSaveAs)
	ON_UPDATE_COMMAND_UI(ID_FILE_OPEN, OnUpdateFileOpen)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY, OnUpdateEditCopy)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE, OnUpdateEditPaste)
	ON_COMMAND(ID_EDIT_PASTE, OnEditPaste)
	ON_UPDATE_COMMAND_UI(ID_FILE_OPEN_DVI, OnUpdateFileOpenDvi)
	ON_UPDATE_COMMAND_UI(ID_FILE_OPEN_LOG, OnUpdateFileOpenLog)
	ON_UPDATE_COMMAND_UI(ID_FILE_OPEN_PDF, OnUpdateFileOpenPdf)
	ON_UPDATE_COMMAND_UI(ID_FILE_OPEN_PS, OnUpdateFileOpenPs)
	ON_COMMAND(ID_FILE_OPEN_DVI, OnFileOpenDvi)
	ON_COMMAND(ID_FILE_OPEN_LOG, OnFileOpenLog)
	ON_COMMAND(ID_FILE_OPEN_PDF, OnFileOpenPdf)
	ON_COMMAND(ID_FILE_OPEN_PS, OnFileOpenPs)
	ON_UPDATE_COMMAND_UI(ID_TO_PS, OnUpdateToPs)
	ON_UPDATE_COMMAND_UI(ID_TO_PDF, OnUpdateToPdf)
	ON_COMMAND(ID_TO_PDF, OnToPdf)
	ON_COMMAND(ID_TO_PS, OnToPs)
	ON_COMMAND(ID_HELP_PDF, OnHelpPdf)
	ON_COMMAND(ID_GF_TO_DVI, OnGfToDvi)
	ON_UPDATE_COMMAND_UI(ID_GF_TO_DVI, OnUpdateGfToDvi)
	ON_UPDATE_COMMAND_UI(ID_STOP_PROCESS, OnUpdateStopProcess)
	ON_COMMAND(ID_STOP_PROCESS, OnStopProcess)
	ON_COMMAND(ID_ERROR_ANALYSE, OnErrorAnalyse)
	ON_UPDATE_COMMAND_UI(ID_ERROR_ANALYSE, OnUpdateErrorAnalyse)
	ON_UPDATE_COMMAND_UI(ID_TESTFONT, OnUpdateTestfont)
	ON_COMMAND(ID_TESTFONT, OnTestfont)
	ON_COMMAND(ID_FONTCHART, OnFontchart)
	ON_UPDATE_COMMAND_UI(ID_FONTCHART, OnUpdateFontchart)
	ON_COMMAND(ID_NFSSFONT, OnNfssfont)
	ON_UPDATE_COMMAND_UI(ID_NFSSFONT, OnUpdateNfssfont)
	ON_COMMAND(ID_ARBITRARY_COMMAND, OnArbitraryCommand)
	ON_UPDATE_COMMAND_UI(ID_ARBITRARY_COMMAND, OnUpdateArbitraryCommand)
	ON_COMMAND(ID_LAST_DVI, OnLastDvi)
	ON_UPDATE_COMMAND_UI(ID_LAST_DVI, OnUpdateLastDvi)
	ON_COMMAND(ID_LAST_DVI_PS, OnLastDviPs)
	ON_UPDATE_COMMAND_UI(ID_LAST_DVI_PS, OnUpdateLastDviPs)
	ON_COMMAND(ID_LAST_TEX, OnLastTex)
	ON_UPDATE_COMMAND_UI(ID_LAST_TEX, OnUpdateLastTex)
	ON_COMMAND(ID_LAST_TEX_HTML, OnLastTexHtml)
	ON_UPDATE_COMMAND_UI(ID_LAST_TEX_HTML, OnUpdateLastTexHtml)
	ON_COMMAND(ID_LATEX2HTML, OnLatex2html)
	ON_UPDATE_COMMAND_UI(ID_LATEX2HTML, OnUpdateLatex2html)
	ON_COMMAND(ID_LATEX2HTML_OPTION, OnLatex2htmlOption)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGuishellDoc NX̍\z/

extern BOOL DontShowGuishellMessage;
extern BOOL g_bNonClipping;
extern BOOL g_bDisableInfo;
CGuishellDoc::CGuishellDoc()
{
	// TODO: ̈ʒuɂPxĂ΂\zp̃R[hǉĂB
	m_task = NULL;
	m_pUserInput = NULL;
	m_szFullPath = NULL;
	m_szFileName = NULL;
	m_szTEXMF = NULL;
	m_parrayFormatFiles = NULL;
	m_parrayFormatFileProperties = NULL;
	m_parrayFile = NULL;
	m_nFixExecType = 0;
	tell_line = FALSE;
	DontShowGuishellMessage = AfxGetApp()->GetProfileInt( "General", "DontShowGuishellMessage", FALSE );
	g_bNonClipping = AfxGetApp()->GetProfileInt( "General", "ConClipping", FALSE );
	g_bDisableInfo = AfxGetApp()->GetProfileInt( "General", "DisableInfo", FALSE );
	m_bShowingLog = FALSE;
	DVIPSpaper.use_struct = FALSE;
	m_bCreateTag = AfxGetApp()->GetProfileInt( "Program", "CreateTag", TRUE );
	srctex.m_nType    = AfxGetApp()->GetProfileInt( "SrcTeX", "Type", SRCTEXTEX );
	srctex.m_bCR      = AfxGetApp()->GetProfileInt( "SrcTeX", "CR", FALSE );
	srctex.m_bDISPLAY = AfxGetApp()->GetProfileInt( "SrcTeX", "DISPLAY", FALSE );
	srctex.m_bHBOX    = AfxGetApp()->GetProfileInt( "SrcTeX", "HBOX", FALSE );
	srctex.m_bMATH    = AfxGetApp()->GetProfileInt( "SrcTeX", "MATH", TRUE );
	srctex.m_bPAR     = AfxGetApp()->GetProfileInt( "SrcTeX", "PAR", TRUE );
	srctex.m_bPAREND  = AfxGetApp()->GetProfileInt( "SrcTeX", "PAREND", FALSE );
	srctex.m_bVBOX    = AfxGetApp()->GetProfileInt( "SrcTeX", "VBOX", FALSE );
	GetTeXInternalConstants();
}

CGuishellDoc::~CGuishellDoc()
{
	if( m_task != NULL ) delete m_task;
	if( m_pUserInput != NULL ) delete m_pUserInput;
	if( m_szFullPath != NULL ) delete[] m_szFullPath;
	if( m_szFileName != NULL ) delete[] m_szFileName;
	if( m_szTEXMF != NULL ) delete[] m_szTEXMF;
	if( m_parrayFormatFiles != NULL ) delete m_parrayFormatFiles;
	if( m_parrayFormatFileProperties != NULL ) delete m_parrayFormatFileProperties;
	if( m_parrayFile != NULL ) delete m_parrayFile;
}

BOOL CGuishellDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: ̈ʒuɍďǉĂB
	// (SDI hLg͂̃hLgėp܂B)
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CGuishellDoc NX̐ff

#ifdef _DEBUG
void CGuishellDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CGuishellDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CGuishellDoc R}h
void CGuishellDoc::SetupDocument( CView* pView )
{
	static BOOL setuped = FALSE;
	if( setuped == TRUE ) return;
	m_pView = pView;
	g_hWndView = pView->m_hWnd;
	setuped = TRUE;
	SetTEXMF();
	CreateFormatList();
	int fmt_index = AfxGetApp()->GetProfileInt( "General", "FormatIndex", 0 );
	CMainFrame* pCWnd = static_cast<CMainFrame*>(AfxGetMainWnd());
	pCWnd->SetFormatCombo( m_parrayFormatFileProperties, fmt_index );
	pCWnd->SetSrcTeX( AfxGetApp()->GetProfileInt("General", "SrcTeX", FALSE) );
	pCWnd->SetDvipsBar();
	if( given_commandline_param )
	{
		if( g_FormatIndexByCommand >= 0 )
		{
			CMainFrame* pCWnd = static_cast<CMainFrame*>(AfxGetMainWnd());
			pCWnd->SetFormatFileIndex( g_FormatIndexByCommand );
		}
		int p = FindLastChar( g_szFileName, '.' );
		if( p != -1 && lstrcmpi(g_szFileName + p + 1, "lnk") == 0 )
		{
			HRESULT hres;
			IShellLink* psl;
			hres = CoCreateInstance(CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER,
				IID_IShellLink, (void**) &psl );
			if( SUCCEEDED(hres) )
			{
				IPersistFile *ppf;
				WORD wsz[MAX_PATH]; // unicode char.
				char sz[MAX_PATH];  // 8-bit char.
				MultiByteToWideChar( CP_ACP, 0, g_szFileName, -1, (LPWSTR)wsz, MAX_PATH );
				hres = psl->QueryInterface( IID_IPersistFile, (void**)&ppf );
				if( !SUCCEEDED(hres) ) goto failed;
				hres = ppf->Load( (LPWSTR)wsz, STGM_READ );
				if( !SUCCEEDED(hres) ) goto failed;
				WIN32_FIND_DATA wfd;
				lstrcpy( sz, g_szFileName );
				hres = psl->GetPath( sz, MAX_PATH, &wfd, NULL );
				if( !SUCCEEDED(hres) ) goto failed;
				ppf->Release();
				psl->Release();
				lstrcpy( g_szFileName, sz );
				goto success;
			}
			else m_pView->MessageBox( "Failed to link Windows' shell!" );
			failed:
				m_pView->MessageBox( "Failed to get file name!" );
		}
		success:
		OnOpenDocument( g_szFileName );
	}
}

void CGuishellDoc::InitExecute( void )
{
	if( m_task != NULL )
	{
		delete m_task;
		m_task = NULL;
	}
	if( m_parrayFile != NULL )
	{
		delete m_parrayFile;
		m_parrayFile = NULL;
	}
	m_bShowingLog = FALSE;
}


BOOL CGuishellDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	/* This function shall be called when OpenFile dialog closed.
	   We put the codes to create process according to the lpszPathName. */
	// TODO: ̈ʒuɌŗL̍쐬pR[hǉĂ


	if( m_task != NULL && m_task->IsChildProcessExit() == FALSE )
	{
		m_task->AppendString( "̂ߗv͖܂B\n" );
		return TRUE;
	}

	if( shell_exec == FALSE )
		SetPathName( lpszPathName, TRUE );
	else
		SetPathName( lpszPathName, FALSE ); // not add to MRU. 
	if( shell_exec == TRUE )
	{
		ShellExecute( m_pView->m_hWnd, NULL, lpszPathName, NULL, NULL, SW_SHOWNORMAL );
		shell_exec = FALSE;
		return TRUE;
	}

	InitExecute();

	m_pView->SetForegroundWindow();
	if( AfxGetMainWnd()->IsIconic() ) AfxGetMainWnd()->ShowWindow( SW_RESTORE );
	((CGuishellView*)m_pView)->ResetView();
	UpdateAllViews( NULL );
	SetFileName( lpszPathName );

	m_nFileType = GetExtentionType(m_szFileName);
	if( m_nFileType == 0 )
	{
		m_parrayFile = new CDynamicCharArray;
		ReadFile();
		dde_mode = FALSE;
		process_type = 0;
		shell_exec = FALSE;
		force_src = FALSE;
		force_no_src = FALSE;
		return TRUE;
	}

	DWORD exec_type = GetExecuteCommand( m_nFileType );
	m_strCommandline += " ";
	switch( exec_type )
	{
		case FILENAME_ONLY:
			m_strCommandline += m_szFileName;
			break;
		case NEED_FULLPATH:
			m_strCommandline += m_szFullPath;
			break;
		case RUN_ONLY:
			break;
		case CUT_EXTENTION:
		{
			char* ext = NULL;
			int p = FindLastChar( m_szFileName, '.' );
			if( p != -1 )
			{
				int l = lstrlen( m_szFileName );
				ext = new char[l-p+1];
				lstrcpy( ext, m_szFileName+p+1 );
				m_szFileName[p] = NULL;
			}
			m_strCommandline += m_szFileName;
			lstrcat( m_szFileName, ext );
			delete[] ext;
			break;
		}
		case PS2PDF:
		{
			int l = lstrlen( m_szFileName );
			char* pdf = new char[l+2];
			lstrcpy( pdf, m_szFileName );
			int p = FindLastChar( pdf, '.' );
			pdf[p] = NULL;
			lstrcat( pdf, ".pdf" );
			m_strCommandline += m_szFileName;
			m_strCommandline += ' ';
			m_strCommandline += pdf;
			delete[] pdf;
			break;
		}
		case ACROBAT_DISTILLER:
		{
			m_strCommandline += '\"';
			m_strCommandline += m_szFullPath;
			m_strCommandline += '\"';
		}
	}
	MoveToDirectory( m_szFullPath );

	if( m_nFileType == TEX || m_nFileType == DTX )
	{
		GetCheckSum( m_szFileName );
		ReserveAux( m_szFullPath );
	}
	
	// preparation to start the transaction.
/*
	CMainFrame* pCWnd = static_cast<CMainFrame*>(AfxGetMainWnd());
	pCWnd->DisableFormatCombo();
	pCWnd->DisableSrcTeX();
	pCWnd->DisableDvipsBar();
*/
	ExecCommand();
	if( m_task == NULL ) return FALSE;
	if( GetExtentionType(m_szFileName) == PS && exec_type != ACROBAT_DISTILLER)
	{
		m_task->AppendString( "GUI-Shell Message: To create PDF file from PostScript file,\n" );
		m_task->AppendString( "GUI-Shell Message: nothing will be shown on the screen.\n" );
		m_task->AppendString( "GUI-Shell Message: Please wait for a little moment.\n" );
		m_task->AppendString( "GUI-Shell Message: It may take a few minutes.\n" );
	}
	if( GetExtentionType(m_szFileName) == PS && exec_type == ACROBAT_DISTILLER)
	{
		m_task->AppendString( "GUI-Shell Message: To create PDF file from PostScript file,\n" );
		m_task->AppendString( "GUI-Shell Message: we only execute Acrobat Distiller.\n" );
		m_task->AppendString( "GUI-Shell Message: Nothing will be shown in this window.\n" );
	}
	return TRUE;
}

BOOL CGuishellDoc::ExecCommand( const char* command )
{
	if( command != NULL ) m_strCommandline = command;
	m_pView->SetFocus();
	AfxGetMainWnd()->DragAcceptFiles( FALSE );
	m_task = new CConsoleTask( m_pView->m_hWnd );
	if( m_pUserInput != NULL )
		m_pUserInput->ClearBuffer();
	
	if( m_task == NULL ) return FALSE;
	m_task->PleaseTellRenewalByMessage( WM_USER_RENEW_BUFFER );
	m_task->PleaseTellTerminationByMessage( WM_USER_TERMINATION );
	m_task->AppendString( "This is GUI-Shell Version 1.39.2, Copyright(C) 1996- by Yoshiki OTOBE.\n" );
	m_task->AppendString( "All rights reserved.\n" );
	m_task->AppendString( "GUI-Shell Message(command): " );
	m_task->AppendString( m_strCommandline );
	m_task->AppendString( "\n" );
	m_task->AppendString( "\n" );
	m_task->CreateChildProcess( m_strCommandline );
	m_pView->InvalidateRect(NULL);
	return TRUE;
}

void CGuishellDoc::OnFileOpen() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	dde_mode = FALSE;
/*
	char szTeXFile[] = 
		"TeX source files(*.tex)|*.tex|"
		"LaTeX DocStrip files(*.dtx)|*.dtx|"
		"LaTeX installation files(*.ltx;*.ins)|*.ltx;*.ins|"
		"BibTeX to create bib files(*.aux)|*.aux|"
		"MakeIndex to create index files(*.idx)|*.idx|"
		"METAFONT source files(*.mf)|*.mf|"
		"METAPOST source files(*.mp)|*.mp;*.mpx;*.mps|"
		"DVI files to create PS files(*.dvi)|*.dvi|"
		"PS files to create PDF files(*.ps)|*.ps|"
		"GF files to create DVI files(*.gf)|*.gf;*.2602gf|"
		"Log files to view(*.log)|*.log|"
		"All files(*.*)|*.*||";
*/
	char szFile[MAX_PATH];
	wsprintf( szFile, "*.tex" );
		
	OPENFILENAME OpenFileName;
	OpenFileName.lStructSize		= sizeof(OPENFILENAME);
	OpenFileName.hwndOwner			= AfxGetMainWnd()->m_hWnd;
	OpenFileName.hInstance			= NULL;
	OpenFileName.lpstrFilter		= 
		"TeX source files(*.tex)\0*.tex\0"
		"LaTeX DocStrip files(*.dtx)\0*.dtx\0"
		"LaTeX installation files(*.ltx;*.ins)\0*.ltx;*.ins\0"
		"BibTeX to create bib files(*.aux)\0*.aux\0"
		"MakeIndex to create index files(*.idx)\0*.idx\0"
		"METAFONT source files(*.mf)\0*.mf\0"
		"METAPOST source files(*.mp)\0*.mp;*.mpx;*.mps\0"
		"DVI files to create PS files(*.dvi)\0*.dvi\0"
		"PS files to create PDF files(*.ps)\0*.ps\0"
		"GF files to create DVI files(*.gf)\0*.gf;*.2602gf\0"
		"Log files to view(*.log)\0*.log\0"
		"All files(*.*)\0*.*\0";
	OpenFileName.lpstrCustomFilter	= NULL;
	OpenFileName.nMaxCustFilter		= 0;
	OpenFileName.nFilterIndex		= 0;
	OpenFileName.lpstrFile			= szFile;
	OpenFileName.nMaxFile			= MAX_PATH*sizeof(TCHAR);
	OpenFileName.lpstrFileTitle		= NULL;
	OpenFileName.nMaxFileTitle		= 0;
	OpenFileName.lpstrInitialDir	= NULL;
	OpenFileName.lpstrTitle			= NULL; // default title/
	OpenFileName.Flags				= OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_NONETWORKBUTTON;
	OpenFileName.nFileOffset		= 0;
	OpenFileName.nFileExtension		= 0;
	OpenFileName.lpstrDefExt		= "tex";
	OpenFileName.lCustData			= 0;
	OpenFileName.lpfnHook			= NULL;
	OpenFileName.lpTemplateName		= NULL;

	if( GetOpenFileName(&OpenFileName) != 0 )
	{
		OnOpenDocument( OpenFileName.lpstrFile );
	}
		
/*
	CFileDialog dlgFile( TRUE, "tex", NULL, OFN_HIDEREADONLY
	            | OFN_FILEMUSTEXIST | OFN_LONGNAMES 
				| OFN_NONETWORKBUTTON, szTeXFile );
	if( dlgFile.DoModal() == IDOK )
	{
		OnOpenDocument( dlgFile.GetPathName() );
	}
*/


	return;
}

void CGuishellDoc::SetPathName(LPCTSTR lpszPathName, BOOL bAddToMRU) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	/* This function puts the lpszPathName to the inner data area of MFC(CDocument).
	   We have to change the implimentation because when user want to treat the
	   same file that recently used, user cannnot do it unless if we clear the
	   file name from the data area which the current file name is preserved. */
	CDocument::SetPathName(lpszPathName, bAddToMRU);
	// m_strPathName is the inner data area of the CDocunemt class.
	// we clear it, and keep it empty.
	m_strPathName.Empty();
}

BOOL CGuishellDoc::UserInputChar( char c )
{
	if( m_task == NULL ) return FALSE;
	if( m_pUserInput == NULL ) m_pUserInput = new CUserInput;	
	if( m_task->IsChildProcessExit() )
	{
		MessageBeep( MB_ICONEXCLAMATION );
		return FALSE;
	}
	switch( c )
	{
		case 0x08: // back space
			m_pUserInput->DeleteLastChar();
			return TRUE;
		case 0x09: // horizontal tab.
			UserInputChar( ' ' );
			return TRUE;
		case 0x03:
			m_pUserInput->ClearBuffer();
//			m_pUserInput->NormalKey( c );
//			m_task->SendChar( c );
//			m_task->WriteChar( '\n' );
			m_task->SendCtrlC();
			Sleep( 0 );
			AfxGetMainWnd()->SetForegroundWindow();
			AfxGetMainWnd()->SetFocus();
/*
			if( m_task != NULL && m_task->IsChildProcessExit() == FALSE )
			{
				Sleep(0);
				m_task->WriteString( "x\n" );
			}
*/
			return TRUE;
		case 0x04:
			m_pUserInput->ClearBuffer();
			m_pUserInput->NormalKey( c );
			m_task->SendChar( c );
			m_task->WriteChar( '\n' );
			return TRUE;
		case 0x1a: // Ctrl+Z
			m_pUserInput->ClearBuffer();
//			m_pUserInput->NormalKey( c );
			m_task->SendChar( c );
			return TRUE;
		default:
			break;
	}
	if( c != '\n' && c != '\r' )
	{
		m_pUserInput->NormalKey( c );
		return TRUE;
	}
	else
	{
		if( lstrcmp(m_pUserInput->GetData(), "" ) == 0 )
		{
			m_task->WriteChar( '\n' );
			return TRUE;
		}

		if( (*(m_pUserInput->GetData()) == 'e' || *(m_pUserInput->GetData()) == 'x') 
				&& AfxGetApp()->GetProfileInt("General", "DdeTEXEDIT", FALSE) == TRUE )
			tell_line = TRUE;

		if( lstrcmp(m_pUserInput->GetData(), "e") == 0 
			&& (dde_mode && AfxGetApp()->GetProfileInt("General", "DdeTEXEDIT", FALSE)==FALSE) )
		{
			m_pUserInput->ClearBuffer();
			m_task->WriteString( "x\n" );
			tell_line = TRUE;
		}
		else
		{
			int len = lstrlen( m_pUserInput->GetData() );
			char* write_char = new char[len+2];
			wsprintf( write_char, "%s\n", m_pUserInput->GetData() );
			m_task->WriteString( write_char );
			delete[] write_char;
//			m_task->WriteString( m_pUserInput->GetData() );
//			m_task->WriteChar( '\n' );
			m_pUserInput->ClearBuffer();
		}
		return FALSE;
	}
}

const char* CGuishellDoc::GetUserInput( void )
{
	assert( m_pUserInput != NULL );
	return m_pUserInput->GetData();
}

const int CGuishellDoc::GetExtentionType( const char* filename )
{
	ASSERT( filename != NULL );
	int l = lstrlen( filename );
	int r = FindLastChar( filename, '.' );
	if( r == -1 ) return 0;
	if( l - r > 7  || r == l - 1 ) return 0;
	char* temp = new char[7];
	memset( temp, NULL, 7 );
	memcpy( temp, filename + r + 1, l - r - 1 );
	int ret = 0;
	if( lstrcmpi( temp, "tex" ) == 0 ) ret = TEX;
	else if( lstrcmpi( temp, "ins" ) == 0 ) ret = INS;
	else if( lstrcmpi( temp, "dtx" ) == 0 ) ret = DTX;
	else if( lstrcmpi( temp, "ltx" ) == 0 ) ret = LTX;
	else if( lstrcmpi( temp, "aux" ) == 0 ) ret = AUX;
	else if( lstrcmpi( temp, "idx" ) == 0 ) ret = IDX;
	else if( lstrcmpi( temp, "mf" ) == 0 ) ret = MF;
	else if( lstrcmpi( temp, "mp" ) == 0 ) ret = MP;
	else if( lstrcmpi( temp, "mps" ) == 0 ) ret = MP;
	else if( lstrcmpi( temp, "mpx" ) == 0 ) ret = MP;
	else if( lstrcmpi( temp, "dvi" ) == 0 ) ret = DVI;
	else if( lstrcmpi( temp, "ps" ) == 0 ) ret = PS;
	else if( lstrcmpi( temp, "pdf" ) == 0 ) ret = 0;
	else if( lstrcmpi( temp, "log" ) == 0 ) ret = 0;
	else if( lstrcmpi( temp, "gf" ) == 0 ) ret = GF;
	else if( lstrcmpi( temp, "2602gf" ) == 0 ) ret = GF;
	else ret = 0;
	delete [] temp;

	if( m_szFullPath == NULL ) return ret;
	switch( ret )
	{
		case TEX:
			AfxGetApp()->WriteProfileString( "Settings", "LastTeX", m_szFullPath );
			break;
		case DVI:
			AfxGetApp()->WriteProfileString( "Settings", "LastDVI", m_szFullPath );
			break;
	}
	return ret;
}

BOOL CGuishellDoc::CreateExtentionFileName( const char* org_filename, int ext_type, char* ext_filename )
{
	ASSERT( org_filename != NULL );
	ASSERT( ext_filename != NULL );
	ASSERT( ext_type != NULL );
	int l = lstrlen( org_filename );
	int i = FindLastChar( org_filename, '.' );
	if( i == -1 || l - i > 7 || i == l - 1 ) return FALSE;
	memmove( ext_filename, org_filename, i + 1 );
	char* p = ext_filename + i + 1; // distination pointer.
	switch( ext_type )
	{
		case TEX:
			lstrcpy( p, "tex" );
			break;
		case INS:
			lstrcpy( p, "ins" );
			break;
		case DTX:
			lstrcpy( p, "dtx" );
			break;
		case LTX:
			lstrcpy( p, "ltx" );
			break;
		case AUX:
			lstrcpy( p, "aux" );
			break;
		case IDX:
			lstrcpy( p, "idx" );
			break;
		case MF:
			lstrcpy( p, "mf" );
			break;
		case MP:
			lstrcpy( p, "mp" );
			break;
		case DVI:
			lstrcpy( p, "dvi" );
			break;
		case PS:
			if( static_cast<CMainFrame*>(AfxGetMainWnd())->IsDvipsEps() )
				lstrcpy( p, "eps" );
			else
				lstrcpy( p, "ps" );
			break;
		case LOG:
			lstrcpy( p, "log" );
			break;
		case PDF:
			lstrcpy( p, "pdf" );
			break;
		case GF:
			lstrcpy( p, "2602gf" );
		default:
			return FALSE;
	}
	return TRUE;
}

void CGuishellDoc::MoveToDirectory( const char* full_filename )
{
	ASSERT( full_filename != NULL );
	int l = lstrlen( full_filename );
	int i = FindLastChar( full_filename, '\\' );
	if( i == -1 ) return;
	if( i == 0 ) return;
	char* dir = new char[i+2];
	memcpy( dir, full_filename, i+1 );
	if( dir[i-1] == ':' ) // "c:\"̏ꍇɂ͓Ȉ
		dir[i+1] = NULL;
	else
		dir[i] = NULL;
	if( m_task != NULL )
	{
		int l = lstrlen( dir );
		char* temp = new char[l+46];
		wsprintf( temp, "GUI-Shell Message: Change the directory to %s.\n", dir );
		m_task->AppendString( temp );
		delete[] temp;
	}
	SetCurrentDirectory( dir );
	delete[] dir;
	return;
}

void CGuishellDoc::SetFileName( const char* fullpath )
{
	/* In this function, we have to set
	   m_szFullPath for full path name such as "C:\My Documents\foo.tex" and
	   m_szFileName for the file name such as "foo.tex".
	   However, in some case, we get the path name by the short file name form.
	   In such situation, we have to change it to long file name form
	   except the directory part, since we don't give the directory to
	   TeX programs.
	   We assume that the fullpath is not NULL, if it becomes NULL, the
	   system has something wrong.
	   First we free the m_szFullPath and m_szFileName.
	   Next, we check the possibility the fullpath contains short form
	   by checking there exists a `~' symbol.
	   In the case, we use FindFirstFile() API to get the long file name.
	   The API shall return the long name only in the file name part, i.e.,
	   if fullpath is "C:\MYDOCU~1\FOO.TEX", it pass "C:\MYDOCU~1\FOO.TEX",
	   not "C:\My Documents\foo.tex".
	   However, for the purpose that we want to do, it is sufficient. */
	ASSERT( fullpath != NULL );
	if( m_szFullPath != NULL )
	{
		delete [] m_szFullPath;
		m_szFullPath = NULL;
	}
	if( m_szFileName != NULL )
	{
		delete [] m_szFileName;
		m_szFileName = NULL;
	}

	char longname[MAX_PATH];
	lstrcpy( longname, fullpath );
	if( FindFirstChar(longname,'~') != -1 )
	{
		WIN32_FIND_DATA ffd;
		HANDLE hFind = FindFirstFile( longname, &ffd );
		if( hFind == INVALID_HANDLE_VALUE )
		{
			m_pView->MessageBox( "t@C̎擾Ɏs܂B", NULL, MB_OK | MB_ICONEXCLAMATION );
		}
		else
		{
			if( FindFirstChar(ffd.cFileName,'\\') == -1 )
			{
				char directory[MAX_PATH];
				lstrcpy( directory, longname );
				int p = FindLastChar(directory,'\\');
				ASSERT( p != -1 );
				directory[p] = NULL;
				wsprintf( longname, "%s\\%s", directory, ffd.cFileName );
			}
			else
			{
				lstrcpy( longname, ffd.cFileName );
			}
			FindClose( hFind );
		}
	}
	int l = lstrlen( longname );
	m_szFullPath = new char[l+1];
	lstrcpy( m_szFullPath, longname );
	const char* p; // distination;
	int i = FindLastChar( longname, '\\' );
	p = longname + i + 1; // if i == -1, p == longname
	l = lstrlen( p );
	m_szFileName = new char[l+1];
	lstrcpy( m_szFileName, p );
	return;
}

void CGuishellDoc::SetTEXMF( void )
{
	if( m_szTEXMF != NULL ) delete m_szTEXMF;
	m_szTEXMF = new char[1];
	DWORD texmf_size = GetEnvironmentVariable( g_TEXMF, m_szTEXMF, 1 );
	if( texmf_size == 0 )
	{
		if( GuessTEXMF() == FALSE )
		{
			m_pView->MessageBox( "Couldn't guess TEXMF directory.\n"
				"You must set TEXMF(MAIN) and TEXMFCNF to use TeX.\n"
				"Or call your system administrator, sorry." );
			exit( 1 );
		}
	}
	texmf_size = GetEnvironmentVariable( g_TEXMF, m_szTEXMF, 1 );
	delete[] m_szTEXMF;
	m_szTEXMF = new char[texmf_size+1];
	GetEnvironmentVariable( g_TEXMF, m_szTEXMF, texmf_size + 1 );
	return;
}

DWORD CGuishellDoc::GetExecuteCommand( int type )
{
	BOOL pmode = AfxGetApp()->GetProfileInt( "General", "pMode", TRUE );
	BOOL chkoption = FALSE;

	switch( m_nFixExecType )
	{
		case 1:
			m_strCommandline = "tex.exe";
			return FILENAME_ONLY;
		case 2:
			m_strCommandline = "latex.exe";
			return FILENAME_ONLY;
		default:
			break;
	}

	switch( type )
	{
		case TEX:
		{
			CMainFrame* pCWnd = static_cast<CMainFrame*>(AfxGetMainWnd());
			int fmt_index = pCWnd->GetFormatFileIndex();
			const char* fmt_file = (*m_parrayFormatFiles)[fmt_index];
			int l = lstrlen( fmt_file );
			char* format = new char[l+1];
			lstrcpy( format, fmt_file );
			int j = FindLastChar( format, '.' );
			if( j != -1 ) format[j] = NULL;
			char* type = format + j + 1;
			
			m_strCommandline = "";
			
			char temp[MAX_PATH];
			lstrcpy( temp, m_szFileName );
			temp[lstrlen(temp) - 3] = NULL;

			if( pCWnd->GetSrcTeX() && srctex.m_nType == SRCTEXEXE )
			{
				m_strCommandline += "srctex.exe -o";
				m_strCommandline += temp;
				m_strCommandline += "tmp ";
				m_strCommandline += "-i";
				m_strCommandline += temp;
				m_strCommandline += "tex ";
			}

			if( lstrcmp(type, "exe") == 0 )
			{
				m_strCommandline += format;
				m_strCommandline += ".exe";
			}
			else
			{
				if( AfxGetApp()->GetProfileInt("Program", "UseEXE", TRUE) == TRUE )
				{
					m_strCommandline += format;
					m_strCommandline += ".exe";
				}
				else
				{
					if( AfxGetApp()->GetProfileInt("General", "pMode", TRUE) == TRUE )
					{
						m_strCommandline += "ptex.exe";
//						m_strCommandline += "&";
//						m_strCommandline += format;
					}
					else
					{
						m_strCommandline += "tex.exe";
//						m_strCommandline += "&";
//						m_strCommandline += format;
					}
				}
			}

			if( pCWnd->GetSrcTeX() && srctex.m_nType == SRCTEXTEX )
			{
				BOOL add_srctex = FALSE;
				m_strCommandline += " --src-specials";
				if( srctex.m_bCR || srctex.m_bDISPLAY || srctex.m_bHBOX
					|| srctex.m_bMATH || srctex.m_bPAR || srctex.m_bPAREND
					|| srctex.m_bVBOX ) m_strCommandline += "=";
				if( srctex.m_bCR )
				{
					if( add_srctex ) m_strCommandline += ",";
					m_strCommandline += "cr";
					add_srctex = TRUE;
				}
				if( srctex.m_bDISPLAY )
				{
					if( add_srctex ) m_strCommandline += ",";
					m_strCommandline += "display";
					add_srctex = TRUE;
				}
				if( srctex.m_bHBOX )
				{
					if( add_srctex ) m_strCommandline += ",";
					m_strCommandline += "hbox";
					add_srctex = TRUE;
				}
				if( srctex.m_bMATH )
				{
					if( add_srctex ) m_strCommandline += ",";
					m_strCommandline += "math";
					add_srctex = TRUE;
				}
				if( srctex.m_bPAR )
				{
					if( add_srctex ) m_strCommandline += ",";
					m_strCommandline += "par";
					add_srctex = TRUE;
				}
				if( srctex.m_bPAREND )
				{
					if( add_srctex ) m_strCommandline += ",";
					m_strCommandline += "parend";
					add_srctex = TRUE;
				}
				if( srctex.m_bVBOX )
				{
					if( add_srctex ) m_strCommandline += ",";
					m_strCommandline += "vbox";
					add_srctex = TRUE;
				}
			}

			if( lstrcmp(type, "exe") != 0 
				&& AfxGetApp()->GetProfileInt("Program", "UseEXE", TRUE) != TRUE )
			{
				m_strCommandline += " &";
				m_strCommandline += format;
			}
			delete[] format;

			if( pCWnd->GetSrcTeX() && srctex.m_nType == SRCTEXEXE )
			{
				m_strCommandline += " ";
				m_strCommandline += temp;
				m_strCommandline += "tmp";
				return RUN_ONLY;
			}
			break;
		}
		case INS:
			if( IsProcessByLaTeX() )
			{
				if( pmode )
					m_strCommandline = "platex.exe";
				else
					m_strCommandline = "latex.exe";
			}
			else
			{
				if( pmode )
					m_strCommandline = "ptex.exe -ini";
				else
					m_strCommandline = "tex.exe -ini";
			}
			break;
		case DTX:
			if( pmode )
				m_strCommandline = "platex.exe";
			else
				m_strCommandline = "latex.exe";
			break;
		case LTX:
			if( pmode )
				m_strCommandline = "ptex.exe -ini";
			else
				m_strCommandline = "tex.exe -ini";
			break;
		case AUX:
			if( pmode )
				m_strCommandline = "jbibtex.exe";
			else
				m_strCommandline = "bibtex.exe";
			return CUT_EXTENTION;
		case IDX:
			if( AfxGetApp()->GetProfileInt("Program", "CreateIndProgram", 1) == 0 )
				pmode = FALSE;
			if( pmode )
				m_strCommandline = "mendex.exe";
			else
				m_strCommandline = "makeindex.exe";
			AddMakeIndexOption();
			break;
		case MF:
			m_strCommandline = "mf.exe";
			break;
		case MP:
			m_strCommandline = "mpost.exe";
			break;
		case DVI:
			switch( AfxGetApp()->GetProfileInt("Program", "DVItoPS", 0) )
			{
				case 0:
					m_strCommandline = "dvipsk.exe";
					AddDvipsOption();
					break;
				case 1:
					m_strCommandline = "dvi2ps.exe";
					break;
				case 2:
					m_strCommandline = "jdvi2kps.exe";
					break;
				default:
					m_strCommandline = "dvipsk.exe";
					AddDvipsOption();
					break;
			}
			break;
		case PS:
			if( AfxGetApp()->GetProfileInt("Program", "TranslatePS", TRUE) == FALSE )
				return NOPROCESS;
			switch( AfxGetApp()->GetProfileInt("Program", "UseGhostscript", 0) )
			{
				case 0:
					m_strCommandline = "ps2pdf.bat"; // use Ghostscript.
					return PS2PDF;
				case 1:
					m_strCommandline = "acrodist.exe"; // How to use Distiller?
					WinExec( "acrodist.exe", SW_SHOWNORMAL );
					return ACROBAT_DISTILLER;
			}
			break;
		case LOG:
			break;
		case GF:
			m_strCommandline = "GFtoDVI.exe -verbose";
			break;
		default:
			m_strCommandline = "platex.exe";
			break;
	}
	return FILENAME_ONLY;
}

void CGuishellDoc::OnGeneral() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CGeneralDialog dlg;
	dlg.m_nMRU = AfxGetApp()->GetProfileInt( "General", "NumberOfMRU", 9 );
	dlg.m_nPMode = (AfxGetApp()->GetProfileInt( "General", "pMode", 1 )==1)?0:1;
	dlg.m_guessExecutePath = AfxGetApp()->GetProfileInt( "General", "GuessExecutePath", FALSE );
	dlg.m_guessAcrobat = AfxGetApp()->GetProfileInt( "General", "GuessAcrobatPath", FALSE );
	dlg.m_guessGS = AfxGetApp()->GetProfileInt( "General", "GuessGhostscriptPath", FALSE );
	dlg.m_bUseSeparate = AfxGetApp()->GetProfileInt( "Settings", "Separable", FALSE );
	dlg.m_bHideGuishellMessage = AfxGetApp()->GetProfileInt( "General", "DontShowGuishellMessage", FALSE );
	dlg.m_bUseColor = AfxGetApp()->GetProfileInt( "General", "UseColor", TRUE );
	dlg.m_bNonClipping = AfxGetApp()->GetProfileInt( "General", "ConClipping", FALSE );
	dlg.m_bDisableInfo = AfxGetApp()->GetProfileInt( "General", "DisableInfo", FALSE );
	dlg.m_bDdeTEXEDIT = AfxGetApp()->GetProfileInt( "General", "DdeTEXEDIT", FALSE );
	dlg.m_bOutputStderr = AfxGetApp()->GetProfileInt( "General", "OutputSTDERR", TRUE );
	if( dlg.DoModal() == IDOK )
	{
		AfxGetApp()->WriteProfileInt( "General", "NumberOfMRU", dlg.m_nMRU );
		AfxGetApp()->WriteProfileInt( "General", "pMode", (dlg.m_nPMode==1)?0:1 );
		AfxGetApp()->WriteProfileInt( "General", "GuessExecutePath", dlg.m_guessExecutePath );
		AfxGetApp()->WriteProfileInt( "General", "GuessAcrobatPath", dlg.m_guessAcrobat );
		AfxGetApp()->WriteProfileInt( "General", "GuessGhostscriptPath", dlg.m_guessGS );
		AfxGetApp()->WriteProfileInt( "Settings", "Separable", dlg.m_bUseSeparate );
		AfxGetApp()->WriteProfileInt( "General", "DontShowGuishellMessage", dlg.m_bHideGuishellMessage );
		DontShowGuishellMessage = AfxGetApp()->GetProfileInt( "General", "DontShowGuishellMessage", FALSE );
		AfxGetApp()->WriteProfileInt( "General", "UseColor", dlg.m_bUseColor );
		((CGuishellView*)m_pView)->SetColorText( dlg.m_bUseColor );
		AfxGetApp()->WriteProfileInt( "General", "ConClipping", dlg.m_bNonClipping );
		AfxGetApp()->WriteProfileInt( "General", "DisableInfo", dlg.m_bDisableInfo );
		AfxGetApp()->WriteProfileInt( "General", "DdeTEXEDIT", dlg.m_bDdeTEXEDIT );
		AfxGetApp()->WriteProfileInt( "General", "OutputSTDERR", dlg.m_bOutputStderr );
		g_bNonClipping = dlg.m_bNonClipping;
		g_bDisableInfo = dlg.m_bDisableInfo;
	}
}

BOOL CGuishellDoc::IsProcessByLaTeX( void )
{
	CAsklatexDialog dlg;
	dlg.m_radioLaTeX = 0;
	dlg.DoModal();
	if( dlg.m_radioLaTeX == 0 ) return TRUE;
	else return FALSE;
}

void CGuishellDoc::OnProgramSettings() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CPropertySheet ps;
	CTeXProperty ppTeX;
	CSrcTeXProperty ppSrcTeX;
	CDVIProperty ppDVI;
	CPSProperty ppPS;
	CIDXProperty ppIDX;

	ps.SetTitle( "eϊ۸т̐ݒ" );
	ps.AddPage( &ppTeX );
	ps.AddPage( &ppSrcTeX );
	ps.AddPage( &ppIDX );
	ps.AddPage( &ppDVI );
	ps.AddPage( &ppPS );

	ppSrcTeX.m_nType    = srctex.m_nType;
	ppSrcTeX.m_bCR      = srctex.m_bCR;
	ppSrcTeX.m_bDISPLAY = srctex.m_bDISPLAY;
	ppSrcTeX.m_bHBOX    = srctex.m_bHBOX;
	ppSrcTeX.m_bMATH    = srctex.m_bMATH;
	ppSrcTeX.m_bPAR     = srctex.m_bPAR;
	ppSrcTeX.m_bPAREND  = srctex.m_bPAREND;
	ppSrcTeX.m_bVBOX    = srctex.m_bVBOX;

	ppTeX.m_useEXE = AfxGetApp()->GetProfileInt( "Program", "UseEXE", TRUE );
	ppTeX.m_typeMulti = AfxGetApp()->GetProfileInt( "Program", "MultiProcess", 2 );
	ppTeX.m_bCreateTag = AfxGetApp()->GetProfileInt( "Program", "CreateTag", TRUE );
	ppTeX.m_bEmbedSrcTeX = ((CMainFrame*)AfxGetMainWnd())->GetSrcTeX();
	ppDVI.m_nDVIPS = AfxGetApp()->GetProfileInt( "Program", "DVItoPS", 0 );
	ppIDX.m_nMakeIndex = AfxGetApp()->GetProfileInt( "Program", "CreateIndProgram", 1 );
	ppPS.m_useDistiller = AfxGetApp()->GetProfileInt( "Program", "UseGhostscript", 0 );
	if( ps.DoModal() == IDOK )
	{
		AfxGetApp()->WriteProfileInt( "Program", "UseEXE", ppTeX.m_useEXE );
		AfxGetApp()->WriteProfileInt( "Program", "MultiProcess", ppTeX.m_typeMulti );
		AfxGetApp()->WriteProfileInt( "Program", "CreateTag", ppTeX.m_bCreateTag );
		((CMainFrame*)AfxGetMainWnd())->SetSrcTeX( ppTeX.m_bEmbedSrcTeX );
		AfxGetApp()->WriteProfileInt( "Program", "DVItoPS", ppDVI.m_nDVIPS );
		AfxGetApp()->WriteProfileInt( "Program", "CreateIndProgram", ppIDX.m_nMakeIndex );
		AfxGetApp()->WriteProfileInt( "Program", "UseGhostscript", ppPS.m_useDistiller );

		srctex.m_nType    = ppSrcTeX.m_nType;
		srctex.m_bCR      = ppSrcTeX.m_bCR;
		srctex.m_bDISPLAY = ppSrcTeX.m_bDISPLAY;
		srctex.m_bHBOX    = ppSrcTeX.m_bHBOX;
		srctex.m_bMATH    = ppSrcTeX.m_bMATH;
		srctex.m_bPAR     = ppSrcTeX.m_bPAR;
		srctex.m_bPAREND  = ppSrcTeX.m_bPAREND;
		srctex.m_bVBOX    = ppSrcTeX.m_bVBOX;

		AfxGetApp()->WriteProfileInt( "SrcTeX", "Type", srctex.m_nType );
		AfxGetApp()->WriteProfileInt( "SrcTeX", "CR", srctex.m_bCR );
		AfxGetApp()->WriteProfileInt( "SrcTeX", "DISPLAY", srctex.m_bDISPLAY );
		AfxGetApp()->WriteProfileInt( "SrcTeX", "HBOX", srctex.m_bHBOX );
		AfxGetApp()->WriteProfileInt( "SrcTeX", "MATH", srctex.m_bMATH );
		AfxGetApp()->WriteProfileInt( "SrcTeX", "PAR", srctex.m_bPAR );
		AfxGetApp()->WriteProfileInt( "SrcTeX", "PAREND", srctex.m_bPAREND );
		AfxGetApp()->WriteProfileInt( "SrcTeX", "VBOX", srctex.m_bVBOX );
	}
}

void CGuishellDoc::OnRegistFormatFile() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CRegistFormatFile dlg;
	dlg.m_bShowFormatBar = AfxGetApp()->GetProfileInt("General", "ShowFormatBar", TRUE);
	if( dlg.DoModal() == IDOK )
	{
		CreateFormatList();
		CMainFrame* pCWnd = static_cast<CMainFrame*>(AfxGetMainWnd());
		int current_index = pCWnd->GetFormatFileIndex();
		pCWnd->SetFormatCombo( m_parrayFormatFileProperties, current_index );
		AfxGetApp()->WriteProfileInt("General", "ShowFormatBar", dlg.m_bShowFormatBar);
		dlg.m_bShowFormatBar?pCWnd->ShowFormatBar():pCWnd->HideFormatBar();
	}
}

void CGuishellDoc::CreateFormatList( void )
{
	if( m_parrayFormatFiles != NULL ) delete m_parrayFormatFiles;
	if( m_parrayFormatFileProperties != NULL ) delete m_parrayFormatFileProperties;
	m_parrayFormatFiles = new CDynamicCharArray;
	m_parrayFormatFileProperties = new CDynamicCharArray;
	CCfgFile cfg( "guishell.cfg", READONLY );
	if( cfg.IsOpenedFile() == FALSE )
	{
		(*m_parrayFormatFileProperties) << "̫ϯ̧قo^Ă܂";
		(*m_parrayFormatFiles) << "platex.exe";
		return;
	}
	const char* temp = cfg.GetValue( "index" );
	int last_index;
	if( temp == NULL )
	{
		temp = "9";
		last_index = 9;
	}
	else
		last_index = atoi( temp );
	int size_key = lstrlen(temp) + 11;
	char* key = new char[size_key];
	BOOL exist_format = FALSE;
	for( int i = 0; i <= last_index; i++ )
	{
		wsprintf( key, "FormatFile%d", i );
		const char* temp = cfg.GetValue( key );
		if( temp == NULL )
		{
			wsprintf( key, "%d", i );
			temp = cfg.GetValue( key );
			if( temp == NULL ) continue;
		}
		exist_format = TRUE;
		int l = lstrlen( temp );
		int j = FindLastChar( temp, '(' );
		if( j == -1 )
		{
			(*m_parrayFormatFileProperties) << temp;
			(*m_parrayFormatFiles) << temp;
		}
		else
		{
			char* fmt = new char[l+1];
			char* prop = new char[l+1];
			lstrcpy( prop, temp );
			lstrcpy( fmt, temp + j + 1 );
			prop[j] = NULL;
			j = FindLastChar( fmt, ')' );
			if( j != -1 ) fmt[j] = NULL;
			(*m_parrayFormatFileProperties) << prop;
			(*m_parrayFormatFiles) << fmt;
			delete[] fmt;
			delete[] prop;
		}
	}
	delete[] key;
	if( exist_format == FALSE )
	{
		(*m_parrayFormatFileProperties) << "̫ϯ̧قo^Ă܂";
		(*m_parrayFormatFiles) << "platex.exe";
		return;
	}
	return;
}

void CGuishellDoc::ShowErrorInformation( void )
{
	/* G[擾Aʃ_CAO\B
	   KvɉďōsȂB*/
	
	/* reprocess  TRUE ̂Ƃɂ́Aď̌ʂƂ
	   ̊֐Ă΂ĂB
	   xڂ̏I_
	   
	   */

	CTerminateDialog dlg;
	if( g_bDisableInfo == FALSE ) MessageBeep( MB_OK );

	static BOOL reprocess = FALSE;

	static CQueue<DWORD> queue;
	CDynamicCharArray* pInfo = new CDynamicCharArray;
	ERROR_INFO err_info;
	if( reprocess == TRUE ) // now is not first compile
	{
		/* ďsȂĂB
		   queue 玟̏popāȀ */
		int l = lstrlen( m_szFullPath );
		char* fullpath = new char[l+1];
		switch( queue.Pop() )
		{
			case 0:
			    /* ׂĂ̍ď͏IB*/
				delete[] fullpath;
				err_info = CreateErrorInformation(m_task->m_arrayStdout, pInfo );
				goto exiting_routine;
				return;
			case TEX:
				CreateExtentionFileName( m_szFullPath, TEX, fullpath );
				break;
			case AUX:
				CreateExtentionFileName( m_szFullPath, AUX, fullpath );
				break;
			case IDX:
				CreateExtentionFileName( m_szFullPath, IDX, fullpath );
				break;
		}
		OnOpenDocument( fullpath );
		delete[] fullpath;
		delete pInfo;
		return;
	}
	err_info = CreateErrorInformation(m_task->m_arrayStdout, pInfo );
	if( (m_nFileType == TEX || m_nFileType == DTX) && reprocess == FALSE )
	{
	    /* xڂ̏igq tex, dtx ̏ꍇj
		   G[Ăierr_info.tex_errorjIB*/
		BOOL dtx_mode;
		dtx_mode = (m_nFileType==DTX)?TRUE:FALSE;
		if( err_info.tex_error )
			goto exiting_routine;
		DWORD needs_other = CheckNeedsOtherProgram( m_szFullPath, err_info );
		/* 񏈗Ȃ悤Ɏw肳ĂIB*/
		if( IsProcessComplete() == FALSE )
			goto exiting_routine;
		if( needs_other )
		{
		    /* ďKvBďtOāAԂqueuepush */
			reprocess = TRUE;
			int l = lstrlen( m_szFullPath );
			char* fullpath = new char[l+1];
			if( needs_other & BibTeX )
				queue.Push( AUX );
			if( (needs_other & LaTeX) || (needs_other & BibTeX) || (needs_other & MakeIndex) )
				dtx_mode?queue.Push(DTX):queue.Push(TEX);
			if( (needs_other & MakeIndex) )
				queue.Push( IDX );
			if( (needs_other & BibTeX) || (needs_other & MakeIndex) )
				dtx_mode?queue.Push(DTX):queue.Push(TEX);
			/* ŏɏׂƂ擾ď */
			switch( queue.Pop() )
			{
				case TEX:
					CreateExtentionFileName( m_szFullPath, TEX, fullpath );
					break;
				case AUX:
					CreateExtentionFileName( m_szFullPath, AUX, fullpath );
					break;
				case IDX:
					// 1999/06/20: fixed bug, TEX -> IDX. trivial mistake.
					CreateExtentionFileName( m_szFullPath, IDX, fullpath );
					break;
				case DTX:
					CreateExtentionFileName( m_szFullPath, DTX, fullpath );
					break;
			}
			OnOpenDocument( fullpath );
			delete[] fullpath;
			delete pInfo;
			return;
		}
	}
	else if( m_nFileType == MF && reprocess == FALSE )
	{
	    /* MF ̂Ƃ̍ďƂ́Agftopk N邱 */
		if( err_info.tex_error )
			goto exiting_routine;
		if( IsProcessComplete() == FALSE )
			goto exiting_routine;
		reprocess = TRUE;
		int l = lstrlen( m_szFullPath );
		char* fullpath = new char[l+5];
		CreateExtentionFileName( m_szFullPath, GF, fullpath );
		OnOpenDocument( fullpath );
		delete[] fullpath;
		delete pInfo;
		return;
	}

	exiting_routine:;
	/* ^Cv TEX, DTX ̂ƂɌAauxt@CB
	   G[ĂƂɌAۑĂ̂𕜌B
	   łȂ΁AۑĂ̂폜 */
	if( m_nFileType == TEX || m_nFileType == DTX )
	{
		if( err_info.error_exist == TRUE
		    && err_info.tex_error ) RestoreAux( m_szFullPath, FALSE );
		else RestoreAux( m_szFullPath, TRUE ); // gbk 폜
	}
	else if( m_nFileType == DVI )
	{
		DeleteDvipsTmp();
	}

	/* TAGt@C̐ */
	if( (m_bCreateTag == TRUE)
	 && (m_nFileType == TEX || m_nFileType == DTX || m_nFileType == MF) ) // creating tag file.
	{
		int size = lstrlen( m_szFullPath );
		char* filename = new char[size+2];
		lstrcpy( filename, m_szFullPath );
		int p = FindLastChar( filename, '.' );
		filename[p] = NULL;
		lstrcat( filename, ".tag" );
		CTextFile tag( filename, READONLY );
		if( tag.IsOpenedFile() )
		{
			tag.CloseFile();
			DeleteFile( filename );
		}
		if( !tag.OpenFile( filename, WRITEONLY, TRUE ) ){
			if( m_task ) m_task->AppendString( "GUI-Shell Message: CANNOT OPEN TAG FILE.\n" );
		}
		if( tag.IsOpenedFile() )
		{
			if( err_info.error_exist )
			{
				for( UINT i = 0; i <= pInfo->GetLastIndexOfArray(); i++ )
				{
					if( (*pInfo)[i] != NULL )
						tag.AppendLine( (*pInfo)[i] );
				}
			}
			tag.CloseFile();
		}
		delete[] filename;
	}

	/* DDE ɑ΂鉞 */
	if( (m_nFileType != TEX && m_nFileType != MF && m_nFileType != MP) 
		|| err_info.error_exist == FALSE
		|| AfxGetApp()->GetProfileInt("General", "DdeTEXEDIT", FALSE) )
	{
		if( dde_mode == TRUE )
		{
			if( g_szDdeData != NULL )
			{
				delete[] g_szDdeData;
				g_szDdeData = NULL;
			}
			g_szDdeData = new char[6];
			if( tell_line )
				lstrcpy( g_szDdeData, "ERROR" );
			else
				lstrcpy( g_szDdeData, "OK" );
			((CMainFrame*)AfxGetMainWnd())->PostAdviceMessage();
			delete pInfo;
			reprocess = FALSE;
			dde_mode = FALSE;
			tell_line = FALSE;
			process_type = 0;
			shell_exec = FALSE;
			force_src = FALSE;
			force_no_src = FALSE;
			given_commandline_param	= FALSE;
			return;
		}
		else
		{
			dlg.m_pInfo = NULL;
		}
	}
	else
	{
		if( dde_mode == TRUE )
		{
			EnterCriticalSection( &g_csDde );
			if( g_szDdeData != NULL )
			{
				delete[] g_szDdeData;
				g_szDdeData = NULL;
			}
			g_szDdeData = new char[256];
			if( err_info.tex_error == FALSE )
			{
				lstrcpy( g_szDdeData, "OK" );
			}
			else if( tell_line == TRUE ) // there is TeX/LaTeX's serious error.
			{
				const char* line = (*pInfo)[pInfo->GetLastIndexOfArray()];
				if( lstrlen(line) > 255 ) lstrcpy( g_szDdeData, "ERROR" );
				else
				{
					lstrcpy( g_szDdeData, line );
					int p = FindFirstChar( g_szDdeData, '(' );
					if( static_cast<CMainFrame*>(AfxGetMainWnd())->GetSrcTeX() 
							&& p > 4 && _memicmp(g_szDdeData+p-4, ".tmp", 4) == 0 )
						memcpy( g_szDdeData+p-4, ".tex", 4 );
					if( p != -1 ) g_szDdeData[p] = ' ';
					p = FindFirstChar( g_szDdeData, ')' );
					if( p != -1 ) g_szDdeData[p] = NULL;
				}
			}
			else
			{
				lstrcpy( g_szDdeData, "ERROR" );
			}
			LeaveCriticalSection( &g_csDde );
			((CMainFrame*)AfxGetMainWnd())->PostAdviceMessage();
			delete pInfo;
			reprocess = FALSE;
			dde_mode = FALSE;
			tell_line = FALSE;
			process_type = 0;
			shell_exec = FALSE;
			force_src = FALSE;
			force_no_src = FALSE;
			given_commandline_param	= FALSE;
			return;
		}
		else
		{
			dlg.m_pInfo = pInfo;
		}
	}
	if( g_bDisableInfo == FALSE ) dlg.DoModal();
	delete pInfo;
	reprocess = FALSE;
	dde_mode = FALSE;
	process_type = 0;
	shell_exec = FALSE;
	force_src = FALSE;
	force_no_src = FALSE;
	given_commandline_param	= FALSE;
	m_nFixExecType = 0;
}

void CGuishellDoc::GetCheckSum( const char* filename )
{
	int l = lstrlen( filename );
	char* file= new char[l+1];
	lstrcpy( file, filename );
	int p = FindLastChar( file, '.' );
	ASSERT( p != -1 );
	ASSERT( lstrcmpi(file + p + 1, "tex") == 0 || lstrcmpi(file + p + 1, "dtx") == 0 );
	file[p+1] = NULL;

	lstrcat( file, "aux" );
	m_csAux = ::GetCheckSum( file );
	m_nPrevCitation = GetStringCheckSum( PickupLine(file,"\\citation{") );
	file[p+1] = NULL;

	lstrcat( file, "idx" );
	m_csIdx = ::GetCheckSum( file );
	file[p+1] = NULL;

	lstrcat( file, "toc" );
	m_csToc = ::GetCheckSum( file );
	file[p+1] = NULL;

	lstrcat( file, "lot" );
	m_csLot = ::GetCheckSum( file );
	file[p+1] = NULL;

	lstrcat( file, "lof" );
	m_csLof = ::GetCheckSum( file );
	file[p+1] = NULL;


	delete[] file;
}

void CGuishellDoc::ReserveAux( const char* filename )
{
	int l = lstrlen( filename );
	char* file= new char[l+1];
	char* res_file = new char[l+5];
	lstrcpy( file, filename );
	lstrcpy( res_file, filename );
	int p = FindLastChar( file, '.' );
	ASSERT( p != -1 );
	ASSERT( lstrcmpi(file + p + 1, "tex") == 0 || lstrcmpi(file + p + 1, "dtx") == 0 );
	file[p+1] = NULL;
	res_file[p+1] = NULL;

	lstrcat( file, "aux" );
	lstrcat( res_file, "aux.gbk" );

	if( IsFileExist(file) )
		CopyFile( file, res_file, FALSE );

	delete[] file;
	delete[] res_file;
}

void CGuishellDoc::RestoreAux( const char* filename, BOOL delete_only )
{
	/* if delete_only is TRUE, this ftn only delete .gbk file */
	int l = lstrlen( filename );
	char* file= new char[l+1];
	char* res_file = new char[l+5];
	lstrcpy( file, filename );
	lstrcpy( res_file, filename );
	int p = FindLastChar( file, '.' );
	ASSERT( p != -1 );
	ASSERT( lstrcmpi(file + p + 1, "tex") == 0 || lstrcmpi(file + p + 1, "dtx") == 0 );
	file[p+1] = NULL;
	res_file[p+1] = NULL;

	lstrcat( file, "aux" );
	lstrcat( res_file, "aux.gbk" );

	if( m_task ) m_task->AppendString( "Gui-Shell Message: Restoring the old AUX file...\n" );
	if( IsFileExist(res_file) )
	{
		if( delete_only ) DeleteFile( res_file );
		else
		{
			CopyFile( res_file, file, FALSE );
			DeleteFile( res_file );
		}
	}

	delete[] file;
	delete[] res_file;
}

void CGuishellDoc::DeleteDvipsTmp( void )
{
	if( IsFileExist("head.tmp") ) DeleteFile( "head.tmp" );
	if( IsFileExist("body.tmp") ) DeleteFile( "body.tmp" );
}

DWORD CGuishellDoc::CheckNeedsOtherProgram( const char* filename, ERROR_INFO err_info )
{
	CheckSum csAux;
	CheckSum csIdx;
	CheckSum csToc;
	CheckSum csLof;
	CheckSum csLot;
	DWORD citation_checksum;

	int l = lstrlen( filename );
	char* file= new char[l+1];
	lstrcpy( file, filename );
	int p = FindLastChar( file, '.' );
	ASSERT( p != -1 );
	file[p+1] = NULL;

	lstrcat( file, "aux" );
	csAux = ::GetCheckSum( file );
	citation_checksum = GetStringCheckSum( PickupLine(file,"\\citation{") );
	file[p+1] = NULL;

	lstrcat( file, "idx" );
	csIdx = ::GetCheckSum( file );
	file[p+1] = NULL;

	lstrcat( file, "toc" );
	csToc = ::GetCheckSum( file );
	file[p+1] = NULL;

	lstrcat( file, "lot" );
	csLot = ::GetCheckSum( file );
	file[p+1] = NULL;

	lstrcat( file, "lof" );
	csLof = ::GetCheckSum( file );
	file[p+1] = NULL;

	DWORD ret = 0;
	if( CTime(csIdx.dwLastWritten) > CTime(m_csIdx.dwLastWritten) )
	{ // the index file is newer than before.
		if( csIdx.dwCheckSum != m_csIdx.dwCheckSum )
		{ // more the file is different. by check sum.
			ret |= MakeIndex;
		}
	}

	if( CTime(csToc.dwLastWritten) > CTime(m_csToc.dwLastWritten) )
	{ // the toc(table of contents) file is newer than before.
		if( csToc.dwCheckSum != m_csToc.dwCheckSum )
		{ // more the file is different. by check sum.
			ret |= LaTeX;
		}
	}

	if( CTime(csLot.dwLastWritten) > CTime(m_csLot.dwLastWritten) )
	{ // the lot(list of tables) file is newer than before.
		if( csLot.dwCheckSum != m_csLot.dwCheckSum )
		{ // more the file is different. by check sum.
			ret |= LaTeX;
		}
	}

	if( CTime(csLof.dwLastWritten) > CTime(m_csLof.dwLastWritten) )
	{ // the lof(list of figures) file is newer than before.
		if( csLof.dwCheckSum != m_csLof.dwCheckSum )
		{ // more the file is different. by check sum.
			ret |= LaTeX;
		}
	}

	if( CTime(csAux.dwLastWritten) > CTime(m_csAux.dwLastWritten) )
	{
		lstrcat( file, "aux" );
		if( csAux.dwCheckSum != m_csAux.dwCheckSum && m_nPrevCitation != citation_checksum )
		{
			file[p+1] = NULL;
			lstrcat( file, "tex" );
			if( ContainString(file, "\\bibliography{") == TRUE )
				ret |= BibTeX;
		}
		file[p+1] = NULL;

	}

	if( err_info.cite_warning )
	{
		lstrcat( file, "tex" );
		if( ContainString(file, "\\bibliography{") == TRUE )
			ret |= BibTeX;
		else
			ret |= LaTeX;
		file[p+1] = NULL;
	}
	if( err_info.undef_label )
		ret |= LaTeX;
	if( err_info.label_change )
		ret |= LaTeX;
	delete[] file;
	return ret;
}

void CGuishellDoc::OnUserFileOpen( void )
{
	OnOpenDocument( g_szFileName );
	return;
}

void CGuishellDoc::OnMakeindexOption() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CMakeIndexOption dlg;
	dlg.m_bUseLetterOrdering = AfxGetApp()->GetProfileInt( "MakeIndex", "UseLetterOrdering", FALSE );
	dlg.m_bDisableImplicitPageFormation = AfxGetApp()->GetProfileInt( "MakeIndex", "DisableImplicitPageFormation", TRUE );
	dlg.m_bEnableBlankCompression = AfxGetApp()->GetProfileInt( "MakeIndex", "EnableBlankCompression", TRUE );
	dlg.m_bMakeJapaneseIndexHead = AfxGetApp()->GetProfileInt( "MakeIndex", "MakeJapaneseIndexHead", TRUE );
	dlg.m_bForceToOutputKanji = AfxGetApp()->GetProfileInt( "MakeIndex", "ForceToOutputKanji", FALSE );
	if( dlg.DoModal() == IDOK )
	{	
		AfxGetApp()->WriteProfileString( "MakeIndex", "IndexStyle", dlg.m_strStyle );
		AfxGetApp()->WriteProfileString( "MakeIndex", "Dictionary", dlg.m_strDictionary );
		AfxGetApp()->WriteProfileString( "MakeIndex", "IndexStartPage", dlg.m_strPage );
		AfxGetApp()->WriteProfileInt( "MakeIndex", "UseLetterOrdering", dlg.m_bUseLetterOrdering );
		AfxGetApp()->WriteProfileInt( "MakeIndex", "DisableImplicitPageFormation", dlg.m_bDisableImplicitPageFormation );
		AfxGetApp()->WriteProfileInt( "MakeIndex", "EnableBlankCompression", dlg.m_bEnableBlankCompression );
		AfxGetApp()->WriteProfileInt( "MakeIndex", "MakeJapaneseIndexHead", dlg.m_bMakeJapaneseIndexHead );
		AfxGetApp()->WriteProfileInt( "MakeIndex", "ForceToOutputKanji", dlg.m_bForceToOutputKanji );
	}
}

void CGuishellDoc::AddMakeIndexOption( void )
{
	BOOL pmode = AfxGetApp()->GetProfileInt( "General", "pMode", TRUE );
	if( AfxGetApp()->GetProfileInt("Program", "CreateIndProgram", 1) == 0 )
		pmode = FALSE;

	BOOL add_option = FALSE;
	if( AfxGetApp()->GetProfileInt("MakeIndex", "UseLetterOrdering", FALSE) )
	{
		if( add_option == FALSE )
		{
			m_strCommandline += " -";
			add_option = TRUE;
		}
		m_strCommandline += 'l';
	}
	if( AfxGetApp()->GetProfileInt("MakeIndex", "DisableImplicitPageFormation", TRUE) )
	{
//		if( add_option == FALSE )
//		{
			m_strCommandline += " -";
//			add_option = TRUE;
//		}
		m_strCommandline += 'r';
	}
	if( AfxGetApp()->GetProfileInt("MakeIndex", "EnableBlankCompression", TRUE) )
	{
//		if( add_option == FALSE )
//		{
			m_strCommandline += " -";
//			add_option = TRUE;
//		}
		m_strCommandline += 'c';
	}
	if( pmode && AfxGetApp()->GetProfileInt("MakeIndex", "MakeJapaneseIndexHead", TRUE) )
	{
//		if( add_option == FALSE )
//		{
			m_strCommandline += " -";
//			add_option = TRUE;
//		}
		m_strCommandline += 'g';
	}
	if( pmode && AfxGetApp()->GetProfileInt("MakeIndex", "ForceToOutputKanji", FALSE) )
	{
//		if( add_option == FALSE )
//		{
			m_strCommandline += " -";
//			add_option = TRUE;
//		}
		m_strCommandline += 'f';
	}
	if( AfxGetApp()->GetProfileString("MakeIndex", "IndexStyle") != "" )
	{
		m_strCommandline += " -s ";
		m_strCommandline += AfxGetApp()->GetProfileString( "MakeIndex", "IndexStyle" );
	}
	if( AfxGetApp()->GetProfileString("MakeIndex", "Dictionary") != "" )
	{
		m_strCommandline += " -d ";
		m_strCommandline += AfxGetApp()->GetProfileString( "MakeIndex", "Dictionary" );
	}
	if( AfxGetApp()->GetProfileString("MakeIndex", "IndexStartPage", "any") != "" )
	{
		m_strCommandline += " -p ";
		m_strCommandline += AfxGetApp()->GetProfileString( "MakeIndex", "IndexStartPage", "any" );
	}
}

void CGuishellDoc::OnDvipsOption() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CPropertySheet ps;
	CDvipsPaper ppPaper;
	CDvipsPrinter ppPrinter;

	ppPaper.m_nStartPage = AfxGetApp()->GetProfileInt( "dvips", "StartPage", 0 );
	ppPaper.m_nEndPage   = AfxGetApp()->GetProfileInt( "dvips", "EndPage", 0 );
	ppPaper.m_usePhysicalPage = AfxGetApp()->GetProfileInt( "dvips", "UsePhysicalPage", 1 );
	ppPaper.m_bCreateEPS = AfxGetApp()->GetProfileInt( "dvips", "CreateEPS", FALSE );
	ppPaper.m_bLandscape = AfxGetApp()->GetProfileInt( "dvips", "Landscape", FALSE );
	ppPrinter.m_nCMFonts = AfxGetApp()->GetProfileInt( "dvips", "ComputerModernFonts", 0 );
	ppPrinter.m_nPrinterDPI = AfxGetApp()->GetProfileInt( "dvips", "PrinterDPI", GetDefaultPrinterDPI() );
	ppPrinter.m_bUseConfig = AfxGetApp()->GetProfileInt( "dvips", "UseConfig", FALSE );
	ppPrinter.m_strConfig = AfxGetApp()->GetProfileString( "dvips", "ConfigName", "config.ps" );
	ppPaper.m_bHyperTeX = AfxGetApp()->GetProfileInt( "dvips", "HyperTeX", 0 );
	ppPaper.m_bShowDvipsBar = AfxGetApp()->GetProfileInt( "General", "ShowDvipsBar", TRUE );

	ps.SetTitle( "dvips̵߼ݐݒ" );
	ps.AddPage( &ppPaper );
	ps.AddPage( &ppPrinter );
	show_property_sheet:;
	if( ps.DoModal() == IDOK )
	{
		if( ppPaper.m_bCreateEPS == TRUE )
		{
			if( ppPaper.m_nStartPage != ppPaper.m_nEndPage )
			{
				ps.MessageBox( "EPŞٍ쐬߰ނ𐳂w肵ĂB" );
				goto show_property_sheet;
			}
		}
		DVIPSpaper.use_struct = TRUE;
		DVIPSpaper.start_page = ppPaper.m_nStartPage;
		DVIPSpaper.end_page = ppPaper.m_nEndPage;
		DVIPSpaper.use_physical = ppPaper.m_usePhysicalPage;
		DVIPSpaper.create_eps = ppPaper.m_bCreateEPS;
		DVIPSpaper.paper_format = ppPaper.m_strPaperFormat;
		DVIPSpaper.landscape = ppPaper.m_bLandscape;			
		DVIPSpaper.hypertex = ppPaper.m_bHyperTeX;			
		AfxGetApp()->WriteProfileInt( "dvips", "StartPage", ppPaper.m_nStartPage );
		AfxGetApp()->WriteProfileInt( "dvips", "EndPage", ppPaper.m_nEndPage );
		AfxGetApp()->WriteProfileInt( "dvips", "UsePhysicalPage", ppPaper.m_usePhysicalPage );
		AfxGetApp()->WriteProfileInt( "dvips", "CreateEPS", ppPaper.m_bCreateEPS );
		AfxGetApp()->WriteProfileInt( "dvips", "HyperTeX", ppPaper.m_bHyperTeX );
		AfxGetApp()->WriteProfileInt( "dvips", "ComputerModernFonts", ppPrinter.m_nCMFonts );
		AfxGetApp()->WriteProfileInt( "dvips", "PrinterDPI", ppPrinter.m_nPrinterDPI );
		AfxGetApp()->WriteProfileInt( "dvips", "UseConfig", ppPrinter.m_bUseConfig );
		AfxGetApp()->WriteProfileString( "dvips", "ConfigName", ppPrinter.m_strConfig );
		AfxGetApp()->WriteProfileInt( "General", "ShowDvipsBar", ppPaper.m_bShowDvipsBar );
		CMainFrame* pCWnd = static_cast<CMainFrame*>(AfxGetMainWnd());
		ppPaper.m_bShowDvipsBar?pCWnd->ShowDvipsBar():pCWnd->HideDvipsBar();
		pCWnd->SetDvipsBar();
	}
}

void CGuishellDoc::AddDvipsOption( void )
{
//	BOOL f = DVIPSpaper.use_struct;
	CMainFrame* pCWnd = static_cast<CMainFrame*>(AfxGetMainWnd());

	int printer_dpi = GetDefaultPrinterDPI();
	if( printer_dpi == 0 ) printer_dpi = 600;
//	dpi = AfxGetApp()->GetProfileInt( "dvips", "PrinterDPI", dpi );
	int dpi = pCWnd->GetDvipsDpi();
	if( dpi == 0 ) dpi = GetDefaultPrinterDPI();

	char szDPI[12];
	CheckConfigpsDPI( dpi );
	wsprintf( szDPI, " -D%d", dpi );
	m_strCommandline += szDPI;

	if( pCWnd->IsDvipsHyperTeX() == TRUE )
	{
		m_strCommandline += " -z";
	}

//	if( (f == TRUE && DVIPSpaper.create_eps == FALSE) 
//		|| (f == FALSE && AfxGetApp()->GetProfileInt("dvips", "CreateEPS", FALSE) == FALSE) )
	if( pCWnd->IsDvipsEps() == FALSE )
	{
		m_strCommandline += " -t ";
//		m_strCommandline += f?DVIPSpaper.paper_format:AfxGetApp()->GetProfileString( "dvips", "PaperFormat", "a4paper" );
		m_strCommandline += pCWnd->GetDvipsPaper();
//		if( (f == TRUE && DVIPSpaper.landscape == TRUE)
//			|| (f == FALSE && AfxGetApp()->GetProfileInt("dvips", "Landscape", FALSE) == TRUE) )
		if( pCWnd->IsDvipsLandscape() )
		{
			m_strCommandline += " -t landscape";
		}
	}

//	int start_page = f?DVIPSpaper.start_page:AfxGetApp()->GetProfileInt( "dvips", "StartPage", 0 );
	int start_page = pCWnd->GetDvipsStartPage();
//	int last_page = f?DVIPSpaper.end_page:AfxGetApp()->GetProfileInt( "dvips", "EndPage", 0 );
	int last_page = pCWnd->GetDvipsEndPage();
	char pages[72];
//	if( (f == TRUE && DVIPSpaper.create_eps == TRUE) 
//		|| (f == FALSE && AfxGetApp()->GetProfileInt("dvips", "UsePhysicalPage", TRUE)==TRUE) )
	if( pCWnd->IsDvipsEps() || pCWnd->IsDvipsPagePhysical() )
	{
		if( start_page == 0 && last_page != 0 )
		{
			wsprintf( pages, " -l=%d", last_page );
		}
		else if( start_page != 0 && last_page == 0 )
		{
			wsprintf( pages, " -p=%d", start_page );
		}
		else if( start_page != 0 && last_page != 0 )
		{
			wsprintf( pages, " -p=%d -l=%d", start_page, last_page );
		}
		else pages[0] = NULL;
		m_strCommandline += pages;
	}
	else
	{
		if( start_page == 0 && last_page != 0 )
		{
			wsprintf( pages, " -pp 0-%d", last_page );
		}
		else if( start_page != 0 && last_page == 0 )
		{
			wsprintf( pages, " -pp %d-", start_page );
		}
		else if( start_page != 0 && last_page != 0 )
		{
			wsprintf( pages, " -pp %d-%d", start_page, last_page );
		}
		else pages[0] = NULL;
		m_strCommandline += pages;
	}

//	if( (f == TRUE && DVIPSpaper.create_eps == TRUE)
//		|| (f == FALSE && AfxGetApp()->GetProfileInt("dvips", "CreateEPS", FALSE) == TRUE) )
	if( pCWnd->IsDvipsEps() )
	{
		m_strCommandline += " -E1";
	}

	if( AfxGetApp()->GetProfileInt("dvips", "UseConfig", FALSE) )
	{
		CString str = AfxGetApp()->GetProfileString( "dvips", "ConfigName", "config.ps" );
		if( lstrcmpi(str, "config.ps") != 0 )
		{
			int l = lstrlen( str );
			char* cf = new char[l+1];
			char* cf_ext = NULL;
			lstrcpy( cf, str );
			int p = FindFirstChar( cf, '.' );
			if( p != -1 ) cf_ext = cf + p + 1;
			m_strCommandline += " -P ";
			if( cf_ext != NULL ) m_strCommandline += cf_ext;
			delete[] cf;
		}
	}
	else
	{
		switch( AfxGetApp()->GetProfileInt("dvips", "ComputerModernFonts", 0) )
		{
			case 0:
				m_strCommandline += " -P dl";
				break;
			case 1:
				m_strCommandline += " -P bi";
				break;
			default:
				break;
		}
	}

	if( pCWnd->IsDvipsEps() && !dde_mode )
	{
		char szOutput[MAX_PATH];
		lstrcpy( szOutput, m_szFileName );
		int p = FindLastChar( szOutput, '.' );
		if( p != -1 ) szOutput[p] = NULL;
		lstrcat( szOutput, ".eps" );
		m_strCommandline += " -o ";
		m_strCommandline += szOutput;
	}
	return;
}

BOOL CGuishellDoc::IsProcessComplete( void )
{
	switch( AfxGetApp()->GetProfileInt("Program", "MultiProcess", 2) )
	{
		case 0: // always process complete.
			return TRUE;
		case 1: // always once.
			return FALSE;
		case 2: // follows to command line (process_type).
			switch( process_type )
			{
				case PROCESS_COMPLETE:
					return TRUE;
				case PROCESS_ONCE:
					return FALSE;
				default:
					return TRUE;
			}
		case 3:
			switch( process_type )
			{
				case PROCESS_COMPLETE:
					return TRUE;
				case PROCESS_ONCE:
					return FALSE;
				default: // process_type == 0 if no instructions are given.
					return FALSE;
			}
		default:
			return TRUE;
	}
}

void CGuishellDoc::OnFileSaveAs() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	ASSERT( m_szFileName != NULL );
	int l = lstrlen( m_szFileName );
	char* def_name = new char[l+5];
	lstrcpy( def_name, m_szFileName );
	int p = FindLastChar( def_name, '.' );
	if( p != -1 ) def_name[p] = NULL;
	lstrcat( def_name, ".gsl" );

	char szGslFile[] = 
		"Guishell console output(*.gsl)|*.gsl|"
		"All files(*.*)|*.*||";
	CFileDialog dlgFile( FALSE, "gsl", def_name,
	            OFN_LONGNAMES | OFN_NONETWORKBUTTON
				| OFN_HIDEREADONLY, szGslFile );
	if( dlgFile.DoModal() == IDOK )
	{
		CTextFile text( dlgFile.GetPathName() );
		if( text.IsOpenedFile() )
		{
			text.CloseFile();
			DeleteFile( dlgFile.GetPathName() );
		}
		text.OpenFile( dlgFile.GetPathName(), WRITEONLY, TRUE );
		if( text.IsOpenedFile() == FALSE )
		{
			m_pView->MessageBox( "̧قJ܂łB" );
			return;
		}
		for( UINT i = 0; i <= m_task->GetIndexOfLastLine(); i++ )
		{
			text.AppendLine( m_task->GetLine(i) );
		}
	}
}

void CGuishellDoc::OnUpdateFileSaveAs(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	if( m_szFileName == NULL )
		pCmdUI->Enable( FALSE );
	else
		pCmdUI->Enable( TRUE );
}

void CGuishellDoc::OnUpdateFileOpen(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	CMainFrame* pCWnd = static_cast<CMainFrame*>(AfxGetMainWnd());
	if( m_task == NULL )
	{
		pCmdUI->Enable( TRUE );
		pCWnd->EnableFormatCombo();
		pCWnd->EnableSrcTeX();
		pCWnd->EnableDvipsBar();
		return;
	}
	if( m_task->IsChildProcessExit() )
	{
		pCmdUI->Enable( TRUE );
		pCWnd->EnableFormatCombo();
		pCWnd->EnableSrcTeX();
		pCWnd->EnableDvipsBar();
	}
	else
	{
		pCmdUI->Enable( FALSE );
		pCWnd->DisableFormatCombo();
		pCWnd->DisableSrcTeX();
		pCWnd->DisableDvipsBar();
	}
}

void CGuishellDoc::OnUpdateEditCopy(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	if( m_szFileName == NULL || m_bShowingLog == TRUE )
		pCmdUI->Enable( FALSE );
	else
		pCmdUI->Enable( TRUE );
}

void CGuishellDoc::OnEditCopy() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	if( AfxGetMainWnd()->OpenClipboard() == 0 ) return;
	EmptyClipboard();
	CString str = "";
	for( UINT i = 0; i <= m_task->GetIndexOfLastLine(); i++ )
	{
		str += m_task->GetLine(i);
		str += "\r\n";
	}
	int size = lstrlen( str );
	HGLOBAL hMem = GlobalAlloc( GHND, (size+1) );
	char* buffer = static_cast<char*>( GlobalLock(hMem) );
	lstrcpy( buffer, str );
	GlobalUnlock( hMem );
	SetClipboardData( CF_TEXT, hMem ); 
	CloseClipboard();
	// REMARK: Don't free the global memory block
	// since the global block is given to the clip board,
	// it is not mine.
}

void CGuishellDoc::OnUpdateEditPaste(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	if( IsClipboardFormatAvailable(CF_TEXT) == TRUE )
		pCmdUI->Enable( TRUE );
	else
		pCmdUI->Enable( FALSE );
	return;
}


void CGuishellDoc::OnEditPaste() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	if( AfxGetMainWnd()->OpenClipboard() == 0 )
		return;
	HANDLE h = GetClipboardData( CF_TEXT );
	if( h == NULL )
	{
		CloseClipboard();
		return;
	}
	size_t size = GlobalSize( h );
	char* buffer = new char[size];
	if( buffer == NULL )
	{
		CloseClipboard();
		return;
	}
	char* data = static_cast<char*>( GlobalLock(h) );
	lstrcpy( buffer, data );
	size = lstrlen( buffer );
	GlobalUnlock( h );
	CloseClipboard();
	for( unsigned int i = 0; i < size; i++ )
	{
//		UserInputChar( buffer[i] );
		m_pView->SendMessage( WM_CHAR, buffer[i] );
	}
	delete[] buffer;
}

void CGuishellDoc::ReadFile( void )
{
	CTextFile text( m_szFullPath, READONLY );
	if( text.IsOpenedFile() == FALSE ) return;
	UINT last_line = text.GetNumberOfLines();
	for( UINT i = 1; i <= last_line; i++ )
	{
		const char* cur_line = text.GetTheLine( i );
		int l = lstrlen( cur_line );
		int size = l + 1;
		for( int i = 0; i < l; i++ )
		{
			if( cur_line[i] == '\t' ) size += 3;
		}
		char* line = new char[size];
		int add = 0;
		for( int i = 0; i <= l; i++ )
		{
			if( cur_line[i] != '\t' ) line[i+add] = cur_line[i];
			else
			{
				for( int k = 0; k < 4; k++ )
					line[i+k+add] = ' ';
				add += 3;
			}
		}
		(*m_parrayFile) << line;
		delete[] line;
	}
	SendMessage( m_pView->m_hWnd, WM_USER_RENEW_BUFFER, 0, last_line - 1 );
}

void CGuishellDoc::OnUpdateFileOpenDvi(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	if( m_bShowingLog == TRUE
	 && (pre_log_filetype == TEX || pre_log_filetype == DTX) )
	{
		pCmdUI->Enable( TRUE );
		return;
	}
	if( m_task == NULL )
	{
		pCmdUI->Enable( FALSE );
		return;
	}
	if( (m_nFileType == TEX || m_nFileType == DTX || m_nFileType == GF) 
		 && m_task->IsChildProcessExit() )
		pCmdUI->Enable( TRUE );
	else
		pCmdUI->Enable( FALSE );
}

void CGuishellDoc::OnUpdateFileOpenLog(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	if( m_task == NULL )
	{
		pCmdUI->Enable( FALSE );
		return;
	}
	if( (m_nFileType == TEX || m_nFileType == DTX || m_nFileType == MF ) 
	 && m_task->IsChildProcessExit() )
		pCmdUI->Enable( TRUE );
	else
		pCmdUI->Enable( FALSE );
}

void CGuishellDoc::OnUpdateFileOpenPdf(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	if( m_task == NULL )
	{
		pCmdUI->Enable( FALSE );
		return;
	}
	if( m_nFileType == PS && m_task->IsChildProcessExit() )
		pCmdUI->Enable( TRUE );
	else
		pCmdUI->Enable( FALSE );
}

void CGuishellDoc::OnUpdateFileOpenPs(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	if( m_task == NULL )
	{
		pCmdUI->Enable( FALSE );
		return;
	}
	if( m_nFileType == DVI && m_task->IsChildProcessExit() )
		pCmdUI->Enable( TRUE );
	else
		pCmdUI->Enable( FALSE );
}

void CGuishellDoc::OnFileOpenDvi() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	if( m_szFullPath == NULL ) return;
	int l = lstrlen( m_szFullPath );
	char* fullpath = new char[l+1];
	CreateExtentionFileName( m_szFullPath, DVI, fullpath );
	shell_exec = TRUE;
	OnOpenDocument( fullpath );
	shell_exec = FALSE;	
	delete[] fullpath;	
}

void CGuishellDoc::OnFileOpenLog() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	int l = lstrlen( m_szFullPath );
	char* fullpath = new char[l+2];
	pre_log_filetype = m_nFileType;
	CreateExtentionFileName( m_szFullPath, LOG, fullpath );
	OnOpenDocument( fullpath );
	m_bShowingLog = TRUE;
	delete[] fullpath;	
}

void CGuishellDoc::OnFileOpenPdf() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	int l = lstrlen( m_szFullPath );
	char* fullpath = new char[l+2];
	CreateExtentionFileName( m_szFullPath, PDF, fullpath );
	shell_exec = TRUE;
	OnOpenDocument( fullpath );
	shell_exec = FALSE;	
	delete[] fullpath;	
}

void CGuishellDoc::OnFileOpenPs() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	int l = lstrlen( m_szFullPath );
	char* fullpath = new char[l+1];
	CreateExtentionFileName( m_szFullPath, PS, fullpath );
	shell_exec = TRUE;
	OnOpenDocument( fullpath );
	shell_exec = FALSE;	
	delete[] fullpath;	
}

BOOL CGuishellDoc::CanCloseFrame(CFrameWnd* pFrame) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	if( m_task == NULL ) return TRUE;
	if( m_task->IsChildProcessExit() ) return TRUE;
	int result;
	result = m_pView->MessageBox( "q۾͂܂쒆łB{ɏI܂B\n"
				"iWindows9xɂĂͼтsɂ邩܂Bj",
				"mF", MB_ICONEXCLAMATION | MB_YESNO | MB_DEFBUTTON2 );
	if( result == IDYES )
	{
		m_task->TerminateChildProcess();
		return TRUE;
	}
	else
	{
		return FALSE;
	}
	return CDocument::CanCloseFrame(pFrame);
}

void CGuishellDoc::OnUpdateToPs(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	if( m_bShowingLog == TRUE
	&& (pre_log_filetype == TEX || pre_log_filetype == DTX || pre_log_filetype == GF) )
	{
		pCmdUI->Enable( TRUE );
		return;
	}
	if( m_task == NULL )
	{
		pCmdUI->Enable( FALSE );
		return;
	}
	// if current file is tex or dtx, we just have DVI file.
	if( (m_nFileType == TEX || m_nFileType == DTX || m_nFileType == GF || m_nFileType == 0) && m_task->IsChildProcessExit() )
		pCmdUI->Enable( TRUE );
	else
		pCmdUI->Enable( FALSE );
}

void CGuishellDoc::OnUpdateToPdf(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	if( m_task == NULL )
	{
		pCmdUI->Enable( FALSE );
		return;
	}
	// if the current file is dvi, we just created PS file.
	if( m_nFileType == DVI && m_task->IsChildProcessExit() )
		pCmdUI->Enable( TRUE );
	else
		pCmdUI->Enable( FALSE );
}

void CGuishellDoc::OnToPdf() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	int l = lstrlen( m_szFullPath );
	char* fullpath = new char[l+1];
	CreateExtentionFileName( m_szFullPath, PS, fullpath );
	OnOpenDocument( fullpath );
//	m_bShowingLog = TRUE;
	delete[] fullpath;	
}

void CGuishellDoc::OnToPs() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	int l = lstrlen( m_szFullPath );
	char* fullpath = new char[l+1];
	CreateExtentionFileName( m_szFullPath, DVI, fullpath );
	OnOpenDocument( fullpath );
//	m_bShowingLog = TRUE;
	delete[] fullpath;	
}	


void CGuishellDoc::OnHelpPdf() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	char pdf[MAX_PATH];
	GetModuleFileName( NULL, pdf, MAX_PATH );
	int p = FindLastChar( pdf, '.' );
	if( p != -1 )
	{
		pdf[p] = NULL;
		lstrcat( pdf, ".pdf" );
		ShellExecute( m_pView->m_hWnd, NULL, pdf, NULL, NULL, SW_SHOWNORMAL );
	}
}

void CGuishellDoc::OnGfToDvi() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	int l = lstrlen( m_szFullPath );
	char* fullpath = new char[l+5];
	CreateExtentionFileName( m_szFullPath, GF, fullpath );
	OnOpenDocument( fullpath );
	delete[] fullpath;	
}

void CGuishellDoc::OnUpdateGfToDvi(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	if( m_bShowingLog == TRUE && pre_log_filetype == MF )
	{
		pCmdUI->Enable( TRUE );
		return;
	}
	if( m_task == NULL )
	{
		pCmdUI->Enable( FALSE );
		return;
	}
	if( m_nFileType == MF && m_task->IsChildProcessExit() )
		pCmdUI->Enable( TRUE );
	else
		pCmdUI->Enable( FALSE );
}

void CGuishellDoc::OnUpdateStopProcess(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	if( m_task == NULL )
	{
		pCmdUI->Enable( FALSE );
		return;
	}
	if( m_task->IsChildProcessExit() )
	{
		pCmdUI->Enable( FALSE );
		return;
	}
	else
	{
		pCmdUI->Enable( TRUE );
		return;
	}
}

void CGuishellDoc::OnStopProcess() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	if( m_task == NULL ) return;
	if( m_task->IsChildProcessExit() ) return;
	m_task->TerminateChildProcess();	
}

void CGuishellDoc::OnErrorAnalyse() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	if( m_task == NULL ) return;
	CDynamicCharArray* pInfo = new CDynamicCharArray;
	ERROR_INFO err_info;
	err_info = CreateErrorInformation(m_task->m_arrayStdout, pInfo );
	if( err_info.error_exist == FALSE )
	{
		m_pView->MessageBox( "Your source file is perfect (no error and warning)\n"
			"or the last processed file is not TeX source.", "Great!",
			MB_ICONEXCLAMATION );
	}
	else
	{
		int n = pInfo->GetLastIndexOfArray() + 1;
		char num[58];
		wsprintf( num, "There are %d error/warning(s)\n", n );
		CString strErrorInfo = num;
		int last_index = min( 30, pInfo->GetLastIndexOfArray() );
		for( int i = 0; i <= last_index; i++ )
		{
			strErrorInfo += (*pInfo)[i];
			strErrorInfo += '\n';
		}
		m_pView->MessageBox( strErrorInfo, "guishell error/warning information(up to 30)",
			MB_ICONINFORMATION );
	}
	delete pInfo;
}

void CGuishellDoc::OnUpdateErrorAnalyse(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	StandardUpdateUI( pCmdUI );
}

BOOL CGuishellDoc::CheckConfigpsDPI(int dpi)
{
	char* texmf = new char[1];
	DWORD size = GetEnvironmentVariable( g_TEXMF, texmf, 1 );
	delete[] texmf;
	texmf = new char[size+24];
	GetEnvironmentVariable( g_TEXMF, texmf, size+24 );
	SlashToYen( texmf );
	int y = lstrlen( texmf );
	lstrcat( texmf, "\\dvips\\config.ps" );
	CTextFile config( texmf, READ_AND_WRITE );
	if( config.IsOpenedFile() == FALSE )
	{
		texmf[y] = NULL;
		lstrcat( texmf, "\\dvips\\config\\config.ps" );
		config.OpenFile( texmf, READ_AND_WRITE );
		if( config.IsOpenedFile() == FALSE )
		{
			delete[] texmf;
			return FALSE;
		}
	}
	delete[] texmf;
	if( config.IsOpenedFile() == FALSE ) return FALSE;

	UINT m = 0;
	UINT d = 0;
	char current_mode[32];
	for( UINT i = 1; i <= config.GetNumberOfLines(); i++ )
	{
		const char* line = config.GetTheLine( i );
		if( line[0] != 'D' && line[0] != 'M' ) continue;
		if( lstrlen(line) < 3 ) continue;
		if( line[1] != ' ' ) continue;
		if( line[0] == 'D' )
		{
			int current_dpi = atoi( line + 2 );
			if( current_dpi == dpi ) return TRUE;
			else d = i;
		}
		if( line[0] == 'M' )
		{
			strcpy( current_mode, line + 2 );
			m = i;
		}
		if( m && d ) break;
	}
	if( d != 0 )
	{
		char new_dpi[16];
		wsprintf( new_dpi, "D %d", dpi );
		config.OverwriteLine( d, new_dpi );
	}
	char* new_mode_name = NULL;
	if( m != 0 )
	{
		char new_mode[32];
		switch( dpi )
		{
			case 96:
				new_mode_name = "atarins";
				break;
			case 118:
				new_mode_name = "pcprevw";
				break;
			case 160:
				new_mode_name = "nectzo";
				break;
			case 180:
				new_mode_name = "lqlores";
				break;
			case 200:
				new_mode_name = "highfax";
				break;
			case 240:
				new_mode_name = "canonlbp";
				break;
			case 300:
				new_mode_name = "CanonCX";
				break;
			case 320:
				new_mode_name = "neclm";
				break;
			case 360:
				new_mode_name = "nechi";
				break;
			case 400:
				new_mode_name = "nexthi";
				break;
			case 600:
				new_mode_name = "canonex";
				break;
			case 720:
				new_mode_name = "esphi";
				break;
			case 1200:
				new_mode_name = "ultre";
				break;
			case 2400:
				new_mode_name = "supre";
				break;
			default:
				new_mode_name = NULL;
				break;
		}
		if( new_mode_name )
		{
			wsprintf( new_mode, "M %s", new_mode_name );
			config.OverwriteLine( m, new_mode );
		}
	}
	if( new_mode_name != NULL )
		CheckTEXMFCNF_TEXPK( new_mode_name );
	return TRUE;
}

void CGuishellDoc::CheckTEXMFCNF_TEXPK( const char* new_mode_name )
{
	if( new_mode_name == NULL ) return;
	CString texmfcnf_file = GetTEXMFCNF();
	CCfgFile texmfcnf( texmfcnf_file, READ_AND_WRITE );
	if( texmfcnf.IsOpenedFile() == FALSE ) return;

	char* v_pkfonts = texmfcnf.GetValue( "PKFONTS" );
	if( v_pkfonts == NULL ) return;
	int l = lstrlen( v_pkfonts );
	char* pkfonts = new char[l+33];
	lstrcpy( pkfonts, v_pkfonts );

	ReplaceString( pkfonts, "atarins", new_mode_name );
	ReplaceString( pkfonts, "pcprevw", new_mode_name );
	ReplaceString( pkfonts, "nectzo", new_mode_name );
	ReplaceString( pkfonts, "lqlores", new_mode_name );
	ReplaceString( pkfonts, "highfax", new_mode_name );
	ReplaceString( pkfonts, "canonlbp", new_mode_name );
	ReplaceString( pkfonts, "CanonCX", new_mode_name );
	ReplaceString( pkfonts, "neclm", new_mode_name );
	ReplaceString( pkfonts, "nechi", new_mode_name );
	ReplaceString( pkfonts, "nexthi", new_mode_name );
	ReplaceString( pkfonts, "canonex", new_mode_name );
	ReplaceString( pkfonts, "esphi", new_mode_name );
	ReplaceString( pkfonts, "ultre", new_mode_name );
	ReplaceString( pkfonts, "supre", new_mode_name );

	texmfcnf.ModifyEntry( "PKFONTS", pkfonts );
}

void CGuishellDoc::OnTestfont() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	char trans_file[MAX_PATH];
	CopyTEXMF( trans_file );
	lstrcat( trans_file, "\\tex\\plain\\base\\testfont.tex" );
	m_nFixExecType = 1;
	OnOpenDocument( trans_file );
}

void CGuishellDoc::OnUpdateTestfont(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	StandardUpdateUI( pCmdUI );
}

void CGuishellDoc::OnFontchart() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	char trans_file[MAX_PATH];
	CopyTEXMF( trans_file );
	lstrcat( trans_file, "\\tex\\plain\\misc\\fontchart.tex" );
	m_nFixExecType = 1;
	OnOpenDocument( trans_file );
}

void CGuishellDoc::OnUpdateFontchart(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	StandardUpdateUI( pCmdUI );
}

void CGuishellDoc::OnNfssfont() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	char trans_file[MAX_PATH];
	CopyTEXMF( trans_file );
	lstrcat( trans_file, "\\tex\\latex\\base\\nfssfont.tex" );
	m_nFixExecType = 2;
	OnOpenDocument( trans_file );
}

void CGuishellDoc::OnUpdateNfssfont(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	StandardUpdateUI( pCmdUI );
}


void CGuishellDoc::OnArbitraryCommand() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CCommandDialog dlg;
	if( dlg.DoModal() == IDOK )
	{
		char temp[MAX_PATH];
		int s = FindFirstChar( dlg.m_strCommand, ' ' );
		int d = -1;
		if( dlg.m_strCommand[0] == '"' )
		{
			d = FindFirstChar( (const char*)dlg.m_strCommand + 1, '"' );
		}
		if( s != -1 )
		{
			lstrcpy( temp, (const char*)dlg.m_strCommand + max(s,d) + 1 );
			MoveToDirectory( temp );
		}
		m_nFileType = 1000; // must not be 0!
		InitExecute();
		ExecCommand( dlg.m_strCommand );
	}
	return;
}

void CGuishellDoc::OnUpdateArbitraryCommand(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	StandardUpdateUI( pCmdUI );
}

BOOL CGuishellDoc::StandardUpdateUI( CCmdUI* pCmdUI )
{
	if( m_task == NULL )
	{
		pCmdUI->Enable( TRUE );
		return TRUE;
	}
	if( m_task->IsChildProcessExit() )
	{
		pCmdUI->Enable( TRUE );
		return TRUE;
	}
	else
	{
		pCmdUI->Enable( FALSE );
		return FALSE;
	}
}

void CGuishellDoc::OnLastDvi() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CString last_file = AfxGetApp()->GetProfileString( "Settings", "LastDVI", "" ); 
	if( last_file[0] == NULL ) return;
	shell_exec = TRUE;
	OnOpenDocument( last_file );
	shell_exec = FALSE;	
}

void CGuishellDoc::OnUpdateLastDvi(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	if( StandardUpdateUI(pCmdUI) == FALSE ) return;
//	CString last_file = AfxGetApp()->GetProfileString( "Settings", "LastDVI", "" ); 
//	if( last_file[0] == NULL ) pCmdUI->Enable( FALSE );
}

void CGuishellDoc::OnLastDviPs() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CString last_file = AfxGetApp()->GetProfileString( "Settings", "LastDVI", "" ); 
	if( last_file[0] == NULL ) return;
//	shell_exec = TRUE;
	OnOpenDocument( last_file );
//	shell_exec = FALSE;	
}

void CGuishellDoc::OnUpdateLastDviPs(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	if( StandardUpdateUI(pCmdUI) == FALSE ) return;
//	CString last_file = AfxGetApp()->GetProfileString( "Settings", "LastDVI", "" ); 
//	if( last_file[0] == NULL ) pCmdUI->Enable( FALSE );
}

void CGuishellDoc::OnLastTex() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CString last_file = AfxGetApp()->GetProfileString( "Settings", "LastTeX", "" ); 
	if( last_file[0] == NULL ) return;
	OnOpenDocument( last_file );
}

void CGuishellDoc::OnUpdateLastTex(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	if( StandardUpdateUI(pCmdUI) == FALSE ) return;
//	CString last_file = AfxGetApp()->GetProfileString( "Settings", "LastTeX", "" ); 
//	if( last_file[0] == NULL ) pCmdUI->Enable( FALSE );
}

void CGuishellDoc::OnLastTexHtml() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CString last_file = AfxGetApp()->GetProfileString( "Settings", "LastTeX", "" ); 
	if( last_file[0] == NULL ) return;
	ExecLaTeX2HTML( last_file );
}

void CGuishellDoc::OnUpdateLastTexHtml(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	if( StandardUpdateUI(pCmdUI) == FALSE ) return;
//	CString last_file = AfxGetApp()->GetProfileString( "Settings", "LastTeX", "" ); 
//	if( last_file[0] == NULL ) pCmdUI->Enable( FALSE );
}

void CGuishellDoc::OnLatex2html() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	dde_mode = FALSE;

	char szFile[MAX_PATH];
	wsprintf( szFile, "*.tex" );
		
	OPENFILENAME OpenFileName;
	OpenFileName.lStructSize		= sizeof(OPENFILENAME);
	OpenFileName.hwndOwner			= AfxGetMainWnd()->m_hWnd;
	OpenFileName.hInstance			= NULL;
	OpenFileName.lpstrFilter		= 
		"TeX source files(*.tex)\0*.tex\0"
		"All files(*.*)\0*.*\0";
	OpenFileName.lpstrCustomFilter	= NULL;
	OpenFileName.nMaxCustFilter		= 0;
	OpenFileName.nFilterIndex		= 0;
	OpenFileName.lpstrFile			= szFile;
	OpenFileName.nMaxFile			= MAX_PATH*sizeof(TCHAR);
	OpenFileName.lpstrFileTitle		= NULL;
	OpenFileName.nMaxFileTitle		= 0;
	OpenFileName.lpstrInitialDir	= NULL;
	OpenFileName.lpstrTitle			= NULL; // default title/
	OpenFileName.Flags				= OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_NONETWORKBUTTON;
	OpenFileName.nFileOffset		= 0;
	OpenFileName.nFileExtension		= 0;
	OpenFileName.lpstrDefExt		= "tex";
	OpenFileName.lCustData			= 0;
	OpenFileName.lpfnHook			= NULL;
	OpenFileName.lpTemplateName		= NULL;

	if( GetOpenFileName(&OpenFileName) != 0 )
	{
		ExecLaTeX2HTML( OpenFileName.lpstrFile );
	}
	return;
}

void CGuishellDoc::ExecLaTeX2HTML( const char* filename )
{
	CString strExec;
	strExec = "latex2html ";

	if( m_szFullPath != NULL )
	{
		delete[] m_szFullPath;
		m_szFullPath = NULL;
	}
	if( m_szFileName != NULL )
	{
		delete[] m_szFileName;
		m_szFileName = NULL;
	}

	int l = lstrlen( filename );
	m_szFullPath = new char[l+1];
	lstrcpy( m_szFullPath, filename );
	const char* p; // distination;
	int i = FindLastChar( filename, '\\' );
	p = filename + i + 1; // if i == -1, p == filename
	l = lstrlen( p );
	m_szFileName = new char[l+1];
	lstrcpy( m_szFileName, p );

	// add options to LaTeX2HTML!
	FILE* fp = fopen( ".latex2html-init", "w" );
	if( fp != NULL )
	{
		if( AfxGetApp()->GetProfileInt("L2H", "LangIndex", 0) == 0 )
		{
			fputs( "$default_language = 'japanese';\n", fp );
			fputs( "$TITLES_LANGUAGE = 'japanese';\n", fp );
			fputs( "$charset = 'x-sjis';\n", fp );
		}
		else
		{
			fputs( "$default_language = 'english';\n", fp );
			fputs( "$TITLES_LANGUAGE = 'english';\n", fp );
			fputs( "$charset = 'iso-8859-1';\n", fp );
		}
		fclose( fp );
	}

	if( AfxGetApp()->GetProfileInt("L2H", "ExtHtm", 0) != FALSE )
		strExec += "-short_extn ";
	if( AfxGetApp()->GetProfileInt("L2H", "SameDir", 0) != FALSE )
		strExec += "-no_subdir ";
	if( AfxGetApp()->GetProfileString("L2H", "EMail", "") != "" )
	{
		strExec += "-address ";
		strExec += AfxGetApp()->GetProfileString("L2H", "EMail", "");
		strExec += " ";
	}
	if( AfxGetApp()->GetProfileInt("L2H", "NoMath", 0) != FALSE )
		strExec += "-no_math ";
	strExec += "-html_version ";
	switch( AfxGetApp()->GetProfileInt("L2H", "VerIndex", 2) )
	{
		case 0:
			strExec += "2.0";
			break;
		case 1:
			strExec += "3.0";
			break;
		case 2:
			strExec += "3.2";
			break;
		case 3:
			strExec += "4.0";
			break;
	}
	if( AfxGetApp()->GetProfileInt("L2H", "Math", 0) != FALSE )
		strExec += ",math";
	strExec += " ";
	strExec += m_szFileName;

	MoveToDirectory( filename );
	GetExtentionType( filename );
	m_nFileType = 1000; // must not be 0!
	InitExecute();
	ExecCommand( strExec );
}

void CGuishellDoc::OnUpdateLatex2html(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	StandardUpdateUI( pCmdUI );
}

void CGuishellDoc::OnLatex2htmlOption() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CPropertySheet ps;
	CL2HGeneralDlg ppGeneral;
	CL2HMathDlg ppMath;

	ppMath.m_strExplain = "IvVƂȗƁA[Novice Mode] ɂȂ܂iAmSpbP[WgpjB"
		"PeLXgŕ\ł鐔͐}ɕϊ܂B\r\n\r\n"
		"uł}ɂvIvV́APȐ}ɕϊ"
		" [Professional Mode] Ӗ܂BAmS pbP[Wgp"
		"̃IvV͏Ɏw肳ĂƂ݂Ȃ܂B\r\n\r\n"
		"ggƁAPʂł͂ȂALPʂŐ}ɕϊ悤ɂȂ܂B"
		"t@C͑܂_E[hԂ͌܂B\r\n"
		"IvVƂw肵Ԃ [Expert Mode] łB";


	ppGeneral.m_bExtHtm = AfxGetApp()->GetProfileInt( "L2H", "ExtHtm", 0 );
	ppGeneral.m_bSameDir = AfxGetApp()->GetProfileInt( "L2H", "SameDir", 0 );
	ppGeneral.m_nLanguage = AfxGetApp()->GetProfileInt( "L2H", "LangIndex", 0 );
	ppGeneral.m_nVersion = AfxGetApp()->GetProfileInt( "L2H", "VerIndex", 2 );
	ppGeneral.m_strEmail = AfxGetApp()->GetProfileString( "L2H", "EMail", "" );
	ppMath.m_bMath = AfxGetApp()->GetProfileInt( "L2H", "Math", 0 );
	ppMath.m_bNoMath = AfxGetApp()->GetProfileInt( "L2H", "NoMath", 0 );

	ps.SetTitle( "LaTeX2HTML̃IvV" );
	ps.AddPage( &ppGeneral );
	ps.AddPage( &ppMath );
	if( ps.DoModal() == IDOK )
	{
		 AfxGetApp()->WriteProfileInt( "L2H", "ExtHtm", ppGeneral.m_bExtHtm );
		 AfxGetApp()->WriteProfileInt( "L2H", "SameDir", ppGeneral.m_bSameDir );
		 AfxGetApp()->WriteProfileInt( "L2H", "LangIndex", ppGeneral.m_nLanguage );
		 AfxGetApp()->WriteProfileInt( "L2H", "VerIndex", ppGeneral.m_nVersion );
		 AfxGetApp()->WriteProfileString( "L2H", "EMail", ppGeneral.m_strEmail );
		 AfxGetApp()->WriteProfileInt( "L2H", "Math", ppMath.m_bMath );
		 AfxGetApp()->WriteProfileInt( "L2H", "NoMath", ppMath.m_bNoMath );
	}
	return;
}
