// guishellDoc.h : CGuishellDoc NX̐錾уC^[tFCX̒`܂B
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_GUISHELLDOC_H__07B883BF_0C34_11D2_BEAB_00A0C92A38FA__INCLUDED_)
#define AFX_GUISHELLDOC_H__07B883BF_0C34_11D2_BEAB_00A0C92A38FA__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "ConsoleTask.h"
#include "CheckSum.h"
#include "util.h"
class CView;
class CUserInput;

class CGuishellDoc : public CDocument
{
protected: // VACY@\݂̂쐬܂B
	CGuishellDoc();
	DECLARE_DYNCREATE(CGuishellDoc);
// Agr[g
protected:
	CView* m_pView;
	CUserInput* m_pUserInput;
	char* m_szFullPath;
	char* m_szFileName;
	char* m_szTEXMF;
	CString m_strCommandline;
	CDynamicCharArray* m_parrayFormatFiles;
	CDynamicCharArray* m_parrayFormatFileProperties;
	CDynamicCharArray* m_parrayFile;
	CConsoleTask* m_task; // the console program
	int m_nFileType;
	BOOL m_bShowingLog;
	BOOL m_bCreateTag;
	int m_nFixExecType;
	// checking variable.
	CheckSum m_csAux; // aux file to check some things.
	CheckSum m_csIdx; // idx file to check need of makeindex.
	CheckSum m_csToc; // toc file to check table of contents.
	CheckSum m_csLof; // lof file to check list of figures.
	CheckSum m_csLot; // lot file to check list of tables. 
	DWORD m_nPrevCitation;

public:
	
// Iy[V
public:
	void SetupDocument( CView* );
	void ShowErrorInformation( void ); // called after terminated.
//I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CGuishellDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	virtual void SetPathName(LPCTSTR lpszPathName, BOOL bAddToMRU = TRUE);
	virtual BOOL CanCloseFrame(CFrameWnd* pFrame);
	//}}AFX_VIRTUAL

// Cve[V
public:
	inline const char* GetLine( int );
	BOOL UserInputChar( char ); // return TRUE if user input is not finished.
	const char* GetUserInput( void );
	virtual ~CGuishellDoc();
	void OnUserFileOpen( void );
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	const int GetExtentionType( const char* );
	BOOL CreateExtentionFileName( const char*, int, char* );
	void MoveToDirectory( const char* );
	void SetFileName( const char* );
	void SetTEXMF( void );
	DWORD GetExecuteCommand( int );
	BOOL IsProcessByLaTeX( void );
	void CreateFormatList( void );
	void GetCheckSum( const char* );
	void DeleteDvipsTmp( void );
	void ReserveAux( const char* );
	void RestoreAux( const char*, BOOL );
	DWORD CheckNeedsOtherProgram( const char*, ERROR_INFO );
	void AddMakeIndexOption( void );
	void AddDvipsOption( void );
	BOOL IsProcessComplete( void );
	void ReadFile( void );
	void CheckTEXMFCNF_TEXPK( const char* );
	void InitExecute( void );
	BOOL ExecCommand( const char* = NULL );
	void ExecLaTeX2HTML( const char* );
	BOOL StandardUpdateUI( CCmdUI* );
// ꂽbZ[W }bv֐
protected:
	BOOL CheckConfigpsDPI( int dpi );
	//{{AFX_MSG(CGuishellDoc)
	afx_msg void OnFileOpen();
	afx_msg void OnGeneral();
	afx_msg void OnProgramSettings();
	afx_msg void OnRegistFormatFile();
	afx_msg void OnMakeindexOption();
	afx_msg void OnDvipsOption();
	afx_msg void OnFileSaveAs();
	afx_msg void OnUpdateFileSaveAs(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileOpen(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditCopy(CCmdUI* pCmdUI);
	afx_msg void OnEditCopy();
	afx_msg void OnUpdateEditPaste(CCmdUI* pCmdUI);
	afx_msg void OnEditPaste();
	afx_msg void OnUpdateFileOpenDvi(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileOpenLog(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileOpenPdf(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileOpenPs(CCmdUI* pCmdUI);
	afx_msg void OnFileOpenDvi();
	afx_msg void OnFileOpenLog();
	afx_msg void OnFileOpenPdf();
	afx_msg void OnFileOpenPs();
	afx_msg void OnUpdateToPs(CCmdUI* pCmdUI);
	afx_msg void OnUpdateToPdf(CCmdUI* pCmdUI);
	afx_msg void OnToPdf();
	afx_msg void OnToPs();
	afx_msg void OnHelpPdf();
	afx_msg void OnGfToDvi();
	afx_msg void OnUpdateGfToDvi(CCmdUI* pCmdUI);
	afx_msg void OnUpdateStopProcess(CCmdUI* pCmdUI);
	afx_msg void OnStopProcess();
	afx_msg void OnErrorAnalyse();
	afx_msg void OnUpdateErrorAnalyse(CCmdUI* pCmdUI);
	afx_msg void OnUpdateTestfont(CCmdUI* pCmdUI);
	afx_msg void OnTestfont();
	afx_msg void OnFontchart();
	afx_msg void OnUpdateFontchart(CCmdUI* pCmdUI);
	afx_msg void OnNfssfont();
	afx_msg void OnUpdateNfssfont(CCmdUI* pCmdUI);
	afx_msg void OnArbitraryCommand();
	afx_msg void OnUpdateArbitraryCommand(CCmdUI* pCmdUI);
	afx_msg void OnLastDvi();
	afx_msg void OnUpdateLastDvi(CCmdUI* pCmdUI);
	afx_msg void OnLastDviPs();
	afx_msg void OnUpdateLastDviPs(CCmdUI* pCmdUI);
	afx_msg void OnLastTex();
	afx_msg void OnUpdateLastTex(CCmdUI* pCmdUI);
	afx_msg void OnLastTexHtml();
	afx_msg void OnUpdateLastTexHtml(CCmdUI* pCmdUI);
	afx_msg void OnLatex2html();
	afx_msg void OnUpdateLatex2html(CCmdUI* pCmdUI);
	afx_msg void OnLatex2htmlOption();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
// INLINE functions.

inline const char* CGuishellDoc::GetLine( int n )
{
	if( m_nFileType == 0 )
	{
		ASSERT( m_parrayFile != NULL );
		return (*m_parrayFile)[n];
	}
	else
	{
		ASSERT( m_task != NULL );
		return m_task->GetLine( n );
	}
}


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio ͑Os̒Oɒǉ̐錾}܂B


#endif // !defined(AFX_GUISHELLDOC_H__07B883BF_0C34_11D2_BEAB_00A0C92A38FA__INCLUDED_)
