// guishellView.cpp : CGuishellView NX̓̒`s܂B
//

#include "stdafx.h"
#include "guishell.h"

#include "guishellDoc.h"
#include "guishellView.h"
#include "MainFrm.h"
#include "util.h"
#include "extention.h"
#include "TextFile.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#ifndef CLASS_MODIFIED_LINE_DEFINED
#define CLASS_MODIFIED_LINE_DEFINED
class CModifiedLine : public CObject
{
public:
	int start_line;
	int last_line;
};
#endif

const int USER_INPUT = 1;
BOOL g_bNonClipping;
BOOL g_bDisableInfo;

/////////////////////////////////////////////////////////////////////////////
// CGuishellView

IMPLEMENT_DYNCREATE(CGuishellView, CScrollView)

BEGIN_MESSAGE_MAP(CGuishellView, CScrollView)
	//{{AFX_MSG_MAP(CGuishellView)
	ON_WM_SIZE()
	ON_WM_KEYDOWN()
	ON_WM_CHAR()
	ON_WM_SHOWWINDOW()
	ON_WM_SETFOCUS()
	ON_WM_KILLFOCUS()
	ON_MESSAGE(WM_USER_RENEW_BUFFER, OnRenewBuffer)
	ON_MESSAGE(WM_USER_TERMINATION, OnTermination)
	ON_MESSAGE(WM_USER_FILE_OPEN, OnUserFileOpen)
	ON_WM_VSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGuishellView NX̍\z/

CGuishellView::CGuishellView()
{
	// TODO: ̏ꏊɍ\zp̃R[hǉĂB
	m_sizeWindow = m_sizeChar = m_sizeCapacity = CSize( 0, 0 );
	m_nTextLines = 0;
	m_nTextWidth = 0;
	m_bUserInputting = FALSE;
	m_bShowCaret = FALSE;
	m_bUserScrolling = FALSE;
}

CGuishellView::~CGuishellView()
{
}

BOOL CGuishellView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB

	return CScrollView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CGuishellView NX̕`
void CGuishellView::OnPrepareDC(CDC* pDC, CPrintInfo* pInfo) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	CScrollView::OnPrepareDC(pDC, pInfo);
}

void CGuishellView::OnDraw(CDC* pDC)
{
	CGuishellDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: ̏ꏊɃlCeBu f[^p̕`R[hǉ܂B
	pDC->SetBkMode( TRANSPARENT );
	if( m_nTextLines == 0 ) return;
	
	CRect rectClip;
	if( pDC->GetClipBox( &rectClip ) == NULLREGION )
	{
		TRACE( "NULL REGION IS GIVEN!\n" );
		// If there is no clipping region, we shall return!
		return;
	}

	ShowCaret( FALSE );
	int start_y = max( 0, rectClip.TopLeft().y/m_sizeChar.cy - 1 );
	int last_y  = rectClip.BottomRight().y/m_sizeChar.cy + 1;
//	TRACE( "%d, %d\n", start_y, last_y );

	CFont* pOldFont = (CFont*)pDC->SelectStockObject( SYSTEM_FIXED_FONT );
	for( int i = max(0,start_y-1); i < min(m_nTextLines,last_y); i++ )
//	for( int i = 0; i < m_nTextLines; i++ )
	{
		const char* sz = pDoc->GetLine( i );
		static BOOL next_latex_warning = FALSE;
		static BOOL next_font_warning = FALSE;
		static BOOL next_tex_warning = FALSE;
		if( m_bUseColor )
		{
			if( IsError(sz) == TRUE ) pDC->SetTextColor( RGB(0xFF,0,0) ); //red
			else if( IsLaTeXWarning(sz) == TRUE || next_latex_warning )
			{
				pDC->SetTextColor( RGB(0,0x7F,0) ); // green
				if( lstrlen(sz) >= 79 && next_latex_warning == FALSE ) next_latex_warning = TRUE;
				else next_latex_warning = next_font_warning = next_tex_warning = FALSE;
			}
			else if( IsLaTeXFontWarning(sz) == TRUE || next_font_warning )
			{
				pDC->SetTextColor( RGB(0,0x7F,0x7F) ); // cyan
				if( next_font_warning == FALSE ) next_font_warning = TRUE;
				else next_latex_warning = next_font_warning = next_tex_warning = FALSE;
			}
			else if( IsTeXWarning(sz) == TRUE || next_tex_warning )
			{
				pDC->SetTextColor( RGB(0,0,0x7F) ); // blue
				if( lstrlen(sz) >= 79 && next_tex_warning == FALSE ) next_tex_warning = TRUE;
				else next_latex_warning = next_font_warning = next_tex_warning = FALSE;
			}
			else if( IsGuishellMessage(sz) == TRUE )
			{
				pDC->SetTextColor( RGB(0x7F,0x7F,0x7F) ); // gray
				next_latex_warning = next_font_warning = next_tex_warning = FALSE;
			}
			/* For dvips, the following order is important. */
			else if( IsDvipsError(sz) == TRUE ) pDC->SetTextColor( RGB(0xFF,0,0) ); // cyan
			else if( IsDvipsMessage(sz) == TRUE ) pDC->SetTextColor( RGB(0,0x7F,0) );
			else if( IsKpathseaMessage(sz) == TRUE ) pDC->SetTextColor( RGB(0,0x7F,0x7F) ); // cyan
			else
			{
				pDC->SetTextColor( RGB(0,0,0) ); // black
				next_latex_warning = next_font_warning = next_tex_warning = FALSE;
			}
		}
		if( g_bNonClipping == TRUE )
		{
//			TRACE( "TextOut, %dth line.\n", i );
			pDC->TextOut( 0, i*m_sizeChar.cy, sz, lstrlen(sz) );
		}
		else
		{
//			TRACE( "ExtTextOut, %dth line.\n", i );
			pDC->ExtTextOut( 0, i*m_sizeChar.cy, NULL, &rectClip, sz, lstrlen(sz), NULL );
		}
	}
	if( m_bUserInputting == TRUE )
	{
		const char* sz = pDoc->GetLine( m_nTextLines - 1 );
		const char* szu = pDoc->GetUserInput();
		int l = lstrlen( sz );
		int m = lstrlen( szu );
		char* temp = new char[l+m+1];
		wsprintf( temp, "%s%s", sz, szu );
		pDC->SetTextColor( RGB(0,0,0) );
		if( g_bNonClipping == TRUE )
		{
			pDC->TextOut( 0, (m_nTextLines-1)*m_sizeChar.cy, temp, lstrlen(temp) );
		}
		else
		{
			pDC->ExtTextOut( 0, (m_nTextLines-1)*m_sizeChar.cy, NULL, &rectClip, temp, lstrlen(temp), NULL );
		}
		delete [] temp;
	}
	pDC->SelectObject( pOldFont );
	m_ptCaret.x = lstrlen( pDoc->GetLine(m_nTextLines - 1) );
	m_ptCaret.x += m_bUserInputting?(lstrlen(pDoc->GetUserInput())):0;
	m_ptCaret.y = m_nTextLines - 1;
	m_ptCaret.x *= m_sizeChar.cx;
	m_ptCaret.y *= m_sizeChar.cy;
	pDC->LPtoDP( &m_ptCaret );
	SetCaretPos( m_ptCaret );
	ShowCaret( TRUE );
}

/////////////////////////////////////////////////////////////////////////////
// CGuishellView NX̐ff

#ifdef _DEBUG
void CGuishellView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CGuishellView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CGuishellDoc* CGuishellView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CGuishellDoc)));
	return (CGuishellDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CGuishellView NX̃bZ[W nh


LRESULT CGuishellView::OnRenewBuffer( WPARAM wParam, LPARAM lParam )
{
	static CModifiedLine modified;
	modified.start_line = (int)wParam;
	modified.last_line = (int)lParam;
	GetDocument()->UpdateAllViews( NULL, 0, &modified );
	return 0;
}

LRESULT CGuishellView::OnTermination( WPARAM, LPARAM )
{
/*
	CMainFrame* pCWnd = static_cast<CMainFrame*>(AfxGetMainWnd());
	pCWnd->EnableFormatCombo();
	pCWnd->EnableSrcTeX();
	pCWnd->EnableDvipsBar();
*/
	InvalidateRect( NULL );
	m_bUserScrolling = TRUE;
	AfxGetMainWnd()->DragAcceptFiles();
	GetDocument()->ShowErrorInformation();
	return 0;
}

LRESULT CGuishellView::OnUserFileOpen( WPARAM, LPARAM )
{
	GetDocument()->OnUserFileOpen();
	return 0;
}

void CGuishellView::OnInitialUpdate() 
{
	CScrollView::OnInitialUpdate();
	GetDocument()->SetupDocument( this );
	SetViewSize();
	SetCaretPos( CPoint(0,0) );
	SetColorText( AfxGetApp()->GetProfileInt( "General", "UseColor", TRUE ) );
}

void CGuishellView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
//	ShowCaret( FALSE );
	static int last_len = 0;
	static int last_line = 0;
	int cx = m_sizeChar.cx;
	int cy = m_sizeChar.cy;
	if( lHint == USER_INPUT )
	{
		int l = lstrlen( GetDocument()->GetLine(m_nTextLines - 1) );
		int lp_start = cy*(max(0, m_nTextLines - 1));
		int lp_last = cy*(m_nTextLines);
		int sp = GetScrollPos( SB_VERT );
		lp_start = max( 0, lp_start - sp );
		lp_last = max( 0, lp_last - sp );
		CPoint ptBegin( l*cx, lp_start );
		CPoint ptEnd( cx*m_sizeCapacity.cx, lp_last );
		CRect rectInvalid;
		rectInvalid.TopLeft() = ptBegin;
		rectInvalid.BottomRight() = ptEnd;
	// the second argument (boolean) specifies that MFC erase the background or not.
	// if FALSE, MFC shall not erace the background.
		InvalidateRect( rectInvalid, TRUE );
		return;
	}
	if( pHint == NULL )
	{
		CScrollView::OnUpdate( pSender, lHint, pHint );
//		TRACE( "NULL hint.\n" );
		return;
	}
	/* In following, lHint != 1(User inputting mode) or
	   pHint != NULL(there is an information of line). */
	int start_line = ((CModifiedLine*)pHint)->start_line;
	int end_line = ((CModifiedLine*)pHint)->last_line;
//	TRACE( "start_line = %d, end_line = %d\n", start_line, end_line );
	m_nTextLines = end_line + 1; // preserve the number of lines;
	if( m_nTextLines < 5 ) m_bUserScrolling = FALSE;
	
	int current_len;
	for( int n = start_line; n <= end_line; n++ )
	{
		current_len = lstrlen( GetDocument()->GetLine(n) );
		m_nTextWidth = max( m_nTextWidth, current_len );
	}
	SetViewSize();
	ScrollToLast( FALSE );

	if( start_line != last_line || end_line > start_line ) last_len = 0;

	int lp_start = cy*start_line;
	int lp_last = cy*(end_line+1);
	int sp = GetScrollPos( SB_VERT );
	lp_start = max( 0, lp_start - sp );
	lp_last = max( 0, lp_last - sp );

//	TRACE( "last_line = %d, start_line = %d, end_line = %d, last_len = %d\n", last_line, start_line, end_line, last_len );
	CPoint ptBegin;
	ptBegin = CPoint( cx*last_len, lp_start );
	CPoint ptEnd( cx*m_sizeCapacity.cx, lp_last );
	CRect rectInvalid;
	rectInvalid.TopLeft() = ptBegin;
	rectInvalid.BottomRight() = ptEnd;
	// the second argument (boolean) specifies that MFC erase the background or not.
	// if FALSE, MFC shall not erace the background.
	InvalidateRect( &rectInvalid, TRUE );
//	InvalidateRect( NULL, TRUE );
	last_len = current_len;
	last_line = end_line;
	return;
}

void CGuishellView::OnSize(UINT nType, int cx, int cy) 
{
	CScrollView::OnSize(nType, cx, cy);

	TEXTMETRIC tm;
	CDC* pDC = GetDC();
	CFont* pOldFont = (CFont*)pDC->SelectStockObject( SYSTEM_FIXED_FONT );
	pDC->GetTextMetrics( &tm );
	m_sizeWindow = CSize( cx, cy );
	m_sizeChar = CSize( tm.tmAveCharWidth, tm.tmHeight );
	m_sizeCapacity = CSize( cx/tm.tmAveCharWidth, cy/tm.tmHeight );
	pDC->SelectObject( pOldFont );
	ReleaseDC( pDC );
	SetViewSize();
	InvalidateRect( NULL );
}

void CGuishellView::ResetView( void )
{
	m_nTextLines = 0;
	m_nTextWidth = 0;
	m_bUserScrolling = FALSE;
	SetViewSize();
}

void CGuishellView::SetViewSize( void )
{
	int cx = m_sizeChar.cx;
	int cy = m_sizeChar.cy;
	if( m_nTextLines == 0 ) // the document is empty!
	{
		SetScrollSizes( MM_TEXT, m_sizeWindow );
		return;
	}
	int doc_size = cy*m_nTextLines;
	if( m_nTextWidth <= m_sizeCapacity.cx )
	{
		CSize sizeDocument( m_sizeWindow.cx, doc_size );
		CSize sizePage( m_sizeWindow.cx/10, cy*m_sizeCapacity.cy/2 );
		CSize sizeLine( m_sizeWindow.cx/100, cy );
		SetScrollSizes( MM_TEXT, sizeDocument, sizePage, sizeLine );
		return;
	}
	CSize sizeDocument( cx*m_nTextWidth, doc_size );
	CSize sizePage( cx*m_sizeCapacity.cx/2, cy*m_sizeCapacity.cy/2 );
	CSize sizeLine( cx, cy );
	SetScrollSizes( MM_TEXT, sizeDocument, sizePage, sizeLine );
	return;
}

void CGuishellView::ScrollToLast( BOOL force_scroll )
{
	/* if force_scroll == FALSE we consider it is good to scroll.
	if user is scrolling, we don't scroll. */
	if( force_scroll == FALSE && m_bUserScrolling == TRUE ) return;
//	int cy = m_sizeChar.cy;
//	CPoint pt = GetScrollPosition();
//	int min, max;
//	GetScrollRange( SB_VERT, &min, &max );
//	pt.y = cy*(m_nTextLines - m_sizeCapacity.cy + 2);
//	if( max <= m_sizeWindow.cy ) return;
//	pt.y = max;
//	ScrollToPosition( pt );
	SendMessage( WM_VSCROLL, MAKEWPARAM(SB_BOTTOM,0), NULL );
	m_bUserScrolling = FALSE;
}

void CGuishellView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	CGuishellDoc* pDoc = GetDocument();
	switch( nChar )
	{
		case VK_HOME: // Home Key
			SendMessage( WM_VSCROLL, MAKEWPARAM(SB_TOP,0), 0 );
			break;
		case VK_END: // End Key
			SendMessage( WM_VSCROLL, MAKEWPARAM(SB_BOTTOM,0), 0 );
			break;
		case VK_PRIOR: // PageUp Key, MAKEWPARAM(lWord,hWord)
			SendMessage( WM_VSCROLL, MAKEWPARAM(SB_PAGEUP,0), 0 );
			return;
		case VK_NEXT:  // PageDown Key
			SendMessage( WM_VSCROLL, MAKEWPARAM(SB_PAGEDOWN,0), 0 );
			break;
		case VK_LEFT: // Left Key
			break;
		case VK_RIGHT: // Right Key
			break;
		case VK_UP:    // Up Key
			SendMessage( WM_VSCROLL, MAKEWPARAM(SB_LINEUP,0), 0 );
			break;
		case VK_DOWN:  //Down Key
			SendMessage( WM_VSCROLL, MAKEWPARAM(SB_LINEDOWN,0), 0 );
			break;
		case VK_DELETE: // Delete Key
			break;
		case VK_ESCAPE: // Esc Key
			m_bUserScrolling = FALSE;
			ScrollToLast();
			return;
			break;
	}
	CScrollView::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CGuishellView::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	if( nChar == 27 ) return;
	m_bUserInputting = GetDocument()->UserInputChar( nChar );
	if( m_bUserInputting == TRUE )
	{
		GetDocument()->UpdateAllViews( NULL, USER_INPUT );
	}
	CScrollView::OnChar(nChar, nRepCnt, nFlags);
}

void CGuishellView::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	CPoint pt;
	pt = GetScrollPosition();
	int cx = m_sizeChar.cx;
	int cy = m_sizeChar.cy;

	static int prev_pos = 0;
	m_bUserScrolling = TRUE;
	switch( nSBCode )
	{
		case SB_PAGEUP:
//			pt.y -= cy*m_sizeCapacity.cy/2;
			break;
		case SB_PAGEDOWN:
//			pt.y += cy*m_sizeCapacity.cy/2;
			break;
		case SB_LINEUP:
//			pt.y -= cy;
			break;
		case SB_LINEDOWN:
//			pt.y += cy;
			break;
		case SB_BOTTOM:
//			pt.y = cy*m_nTextLines;
			m_bUserScrolling = FALSE;
			break;
		case SB_TOP:
//			pt.y = 0;
			break;
		case SB_THUMBTRACK:
//			pt.y = nPos;
			break;
		default:
			break;
	}
//	ScrollToPosition( pt );
//	SetScrollPos( SB_VERT, pt.y );
	CScrollView::OnVScroll(nSBCode, nPos, pScrollBar);
}

void CGuishellView::ShowCaret( BOOL show )
{
	if( show == TRUE && m_bShowCaret == FALSE )
	{
		CScrollView::ShowCaret();
		m_bShowCaret = TRUE;
//		TRACE( "Show the caret.\n" );
		return;
	}
	if( show == FALSE && m_bShowCaret == TRUE )
	{
		CScrollView::HideCaret();
		m_bShowCaret = FALSE;
//		TRACE( "Hide the caret.\n" );
		return;
	}
}

void CGuishellView::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CScrollView::OnShowWindow(bShow, nStatus);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	if( bShow == TRUE )
	{
		InvalidateRect( NULL, TRUE );
	}
}

void CGuishellView::OnSetFocus(CWnd* pOldWnd) 
{
	CScrollView::OnSetFocus(pOldWnd);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	ShowCaret( FALSE );
	CreateSolidCaret( 2, m_sizeChar.cy ); // call after SetViewSize().
//	TRACE( "Create the caret.\n" );
	InvalidateRect( NULL, TRUE );
	ShowCaret( TRUE );	
}

void CGuishellView::OnKillFocus(CWnd* pNewWnd) 
{
	CScrollView::OnKillFocus(pNewWnd);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	ShowCaret( FALSE );	
	DestroyCaret();
//	TRACE( "Destroy the caret.\n" );
	m_bShowCaret = FALSE;
}
